/* **************************************************************** 

   callback-routinen fuer pult2

 (c) Heisch Automation, Werner Heisch
       hw@heisch.inka.de
       http://sites.inka.de/heisch 

Stand 13.06.2016 HW  diverses
Stand 19.02.2009 HW  Pult 2
Stand 16.07.2000 HW  Einbau Test-Funktion


* *****************************************************************
*/
#ifndef FALSE
  #define FALSE 0
#endif


#define cb_debug 0

#include <stdlib.h>
#include <math.h>

#include "forms.h"
#include "p2.h"
#include "p2_data.h"
// #include "rk512_client.h"
#include "simatic_link.h"

/* ---------------               -------------------------- */

extern void init_new_struct(void);
extern void display_con_state(int fstate); // display connection state

/* ====================== Menufunktionen ============================ */
/* ******************************* */

/* Version anzeigen deutsch */
void version_exec_dt()

{
  FL_OBJECT *obj;

  if (help_open) 
     return; 
  help_open = 1;

  fl_show_form(fd_version_dt->version_dt,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Pult Version");

  obj=fl_do_forms(); 

  fl_hide_form(fd_version_dt->version_dt);

  help_open = 0;
}

/* ******************************* */

/* Version anzeigen deutsch */
void version_exec_en()

{
  FL_OBJECT *obj;

  if (help_open) 
     return; 
  help_open = 1;
  fl_show_form(fd_version_en->version_en,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Pult Version");

  obj=fl_do_forms(); 

  fl_hide_form(fd_version_en->version_en);

  help_open = 0;
}

/* ******************************* */

/* Hilfe anzeigen */
void help_exec_dt()

{
  FL_OBJECT *obj;

  if (help_open) 
     return; 
  help_open = 1;

  fl_show_form(fd_help_dt->help_dt,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Pult Hilfe");

  obj=fl_do_forms(); 

  fl_hide_form(fd_help_dt->help_dt);

  help_open = 0;
}



/* ******************************* */

/* Hilfe anzeigen */
void help_exec_en()

{
  FL_OBJECT *obj;

  if (help_open) 
     return; 
  help_open = 1;

  fl_show_form(fd_help_en->help_en,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Pult Hilfe");

  obj=fl_do_forms();

  fl_hide_form(fd_help_en->help_en);

  help_open = 0;
}



/* ******************************* */

/* Kommando-DB definieren */
void kdo_db_define(void)

{
  FL_OBJECT *obj;

  int i;
  double r;

  if (structure_open) return; /* nur einmal aufmachen */
  structure_open = 1;

  pult_xretval = 0;


  fl_show_form(fd_kdo_db_structure->kdo_db_structure,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Command-DB");
  if ( simatic_type == 5) {
    i = 1; 
  } else {
    i = 2;
  }

  fl_set_choice(fd_kdo_db_structure->simatic_type,i);

  fl_set_choice(fd_kdo_db_structure->access_mode,access_mode +1);

  r = cpu_nr; 
   fl_set_counter_value(fd_kdo_db_structure->kdo_cpu_nr,r);
  r = kdo_dbnr; 
   fl_set_counter_value(fd_kdo_db_structure->kdo_db_nr,r);
  r = kdo_dwnr; 
   fl_set_counter_value(fd_kdo_db_structure->kdo_word_nr,r);
}

/* ******************************* */

void cb_kdo_db_structure_end(FL_OBJECT *ob, long data)

{
  cpu_nr = fl_get_counter_value(fd_kdo_db_structure->kdo_cpu_nr);
  kdo_dbnr = fl_get_counter_value(fd_kdo_db_structure->kdo_db_nr);
  kdo_dwnr = fl_get_counter_value(fd_kdo_db_structure->kdo_word_nr);

  fl_hide_form(fd_kdo_db_structure->kdo_db_structure);

  structure_open = 0;
}

/* ******************************* */

int type_to_choice (int type)

{
  int retval;

  switch (type) {
    case BIT1 : retval = 2; break;
    case BIT0 : retval = 3; break;
    case BITT : retval = 4; break;
    default : retval = type; break;
  }
  return retval;
}

/* ******************************* */
int e_choice_to_type (int choice_num)

{
  int retval;

  switch (choice_num) {
    case 2 : retval = BIT1 ; break;
    case 3 : retval = BIT0 ; break;
    case 4 : retval = BITT ; break;
    default : retval = choice_num; break;
  }
  return retval;
}

/* ******************************* */

/* Eingangsbits editieren */
void e_define(int idx)

{
  FL_OBJECT *obj;

  int i;
  double r;
  int choice_val;

  all_def_idx = i=idx;
  if (i>=E_ANZ) return; /* Grenzen pruefen */ 
  if (structure_open) return; /* nur einmal aufmachen */
  structure_open = 1;
  all_def_type = V_TYPE_E;

  pult_xretval = 0;

  fl_show_form(fd_e_structure->e_structure,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Datenstruktur");
  
  r = e_def[i].db_nr; 
   fl_set_spinner_value(fd_e_structure->db_nr,r);
  r = e_def[i].dw_nr; 
   fl_set_spinner_value(fd_e_structure->dbb_nr,r);
  r = e_def[i].bit_nr; 
   fl_set_counter_value(fd_e_structure->bit_nr,r);

  choice_val = type_to_choice(e_def[i].format_type);
  fl_set_choice(fd_e_structure->format_type,choice_val);

  fl_set_input(fd_e_structure->name,e_def[i].name);
}


/* ******************************* */

void cb_e_structure_end (FL_OBJECT *ob, long data)

{
  int i = all_def_idx;

  e_def[i].db_nr = fl_get_spinner_value(fd_e_structure->db_nr);
  e_def[i].dw_nr = fl_get_spinner_value(fd_e_structure->dbb_nr);
  e_def[i].bit_nr = fl_get_counter_value(fd_e_structure->bit_nr);

  e_def[i].format_type = e_choice_to_type (fl_get_choice(fd_e_structure->format_type));

  sstrcpy(e_def[i].name,fl_get_input(fd_e_structure->name),V_NAME_LENGTH);

  set_in(V_DEF,i);

  fl_hide_form(fd_e_structure->e_structure);

  structure_open = 0;
  all_def_type = 0;
  recalc_pa_req = 1; /* trigger the re-calculation of pa */
}

/* ******************************* */

/* Eingangsanalogwerte editieren */
void ew_define(int idx)

{
  FL_OBJECT *obj;

  int i;
  double r;

  all_def_idx = i = idx;
  if (i>=EW_ANZ) return; /* Grenzen pruefen */ 
  if (structure_open) return; /* nur einmal aufmachen */
  structure_open = 1;
  all_def_type = V_TYPE_EW;
  pult_xretval = 0;


  fl_show_form(fd_ew_structure->ew_structure,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Datenstruktur");
  
  r = ew_def[i].db_nr; 
  fl_set_spinner_value(fd_ew_structure->db_nr,r);
  r = ew_def[i].dw_nr; 
  fl_set_spinner_value(fd_ew_structure->dbb_nr,r);
  fl_set_choice(fd_ew_structure->format_type,ew_def[i].format_type);
  fl_set_input(fd_ew_structure->name,ew_def[i].name);
}

/* ******************************* */

void cb_ew_structure_end (FL_OBJECT *ob, long data)

{
  int i = all_def_idx;

  ew_def[i].db_nr = fl_get_spinner_value(fd_ew_structure->db_nr);
  ew_def[i].dw_nr = fl_get_spinner_value(fd_ew_structure->dbb_nr);
  ew_def[i].format_type = fl_get_choice(fd_ew_structure->format_type);
  sstrcpy(ew_def[i].name,fl_get_input(fd_ew_structure->name),V_NAME_LENGTH);
  set_ew(0,i);

  fl_hide_form(fd_ew_structure->ew_structure);

  structure_open = 0;
  all_def_type = 0;
  recalc_pa_req = 1; /* trigger the re-calculation of pa */
}

/* ******************************* */

/* Eingangsanalogwerte eingeben */
void ew_eing(int idx)

{
  FL_OBJECT *obj;

  char hstr[20];
  char fstr[6];
  int i ;
  xretval = 0; /* Returnwert gueltig = 1 */

  all_def_idx = i = idx;
  if (i>=EW_ANZ) return; /* Grenzen pruefen */ 
  if (structure_open) return; /* nur einmal aufmachen */
  if (ew_def[i].format_type < 2) return; /* nur bearbeiten, wenn definiert */
  structure_open = 1;

  pult_xretval = 0;

  fl_show_form(fd_ew_input->ew_input,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "INPUT:");

   switch (ew_def[i].format_type) {
    case KF16  : /* sprintf(hstr,"%li",ew_def[i].lval); */
                 strcpy(fstr,"KF"); 
                 break;
    case KH16  :
    case KM16  : /* sprintf(hstr,"%lx",ew_def[i].lval); */
                 strcpy(fstr,"KH"); 
                 break;
    case KT16  : /* sprintf(hstr,"%.2f s",ew_def[i].val); */
                 strcpy(fstr,"KT"); 
                 break; 
    case KZ16  : /* sprintf(hstr,"%i",ew_def[i].lval); */
                 strcpy(fstr,"KZ"); 
                 break;
    case KF32  : /* sprintf(hstr,"%li",ew_def[i].lval); */
                 strcpy(fstr,"DF"); 
                 break;
    case KH32  : /* sprintf(hstr,"%lx",ew_def[i].lval);  */
                 strcpy(fstr,"DH"); 
                 break;
    case REAL  :
    case S5KG  : /* sprintf(hstr,"%lx",ew_def[i].lval);  */
                 strcpy(fstr,"REAL"); 
                 break;
    default : sprintf(ew_def[i].cval,"--"); 
              strcpy(fstr,"--"); 
                  break;
  }
  strcpy(hstr,"");

  fl_set_object_label(fd_ew_input->format,fstr);
  fl_set_input(fd_ew_input->ew_in,hstr);
  fl_set_input_maxchars(fd_ew_input->ew_in,19);
}

/* ******************************* */

void cb_ew_inp_esc (FL_OBJECT *ob, long data)

{
  char hstr[20];
  char fstr[6];
  short s_outval;
  unsigned long uval; /* Ausgabewert zu Simatic*/
  double rval;

  signed char valid = 0;

  long val;
  float fval;

  int i = all_def_idx;

  strcpy(hstr,fl_get_input(fd_ew_input->ew_in));

   /* Auswertung */      /* NZE = Auswertung zu ungenau */
   switch (ew_def[i].format_type) {
    case KF16 : valid = sscanf(hstr,"%li",&val);
                if ((val > 32767) || (val < -32768)) 
                  valid = 0;
                if (valid) uval = val;
                break;

    case KH16  : /* NZE */
    case KM16  : valid = sscanf(hstr,"%lx",&uval);
                 break;

    case KT16  : valid = sscanf(hstr,"%f",&fval);
                 if(valid) { 
                   if ((fval <= 9990.0) && (fval >= 0.0)) 
                     uval = fval *1000;
                   else 
                     valid = 0;
                  } 
                  break;

    case KZ16  :  valid = sscanf(hstr,"%li",&val);
                  if(valid) { 
                    if ((val > 999) || (val < 0)) 
                      valid = 0;
                  } 
                  uval = val;
                  break;
    case KF32 : valid = sscanf(hstr,"%li",&val);
                if (valid) uval = val;
                break;

    case KH32 : valid = sscanf(hstr,"%lx",&uval);
                 break;

    case REAL : 
    case S5KG : valid = sscanf(hstr,"%f",&fval);
                rval = fval;
                 break;

    default :  valid = 0;
               break;
  }
  if ((data >= 1) && (valid == 1)) {/* wurde mit RETURN beendet */
    def_command(ew_def[i].format_type, ew_def[i].db_nr, ew_def[i].dw_nr, 0, uval, rval); 
   }

  fl_hide_form(fd_ew_input->ew_input);
  structure_open = 0;
}


/* ******************************* */

/* ausgangsbits editieren */
void a_define(int idx)

{
  FL_OBJECT *obj;

  int i;
  double r;

  all_def_idx = i = idx;
  if (i>=A_ANZ) return; /* Grenzen pruefen */ 
  if (structure_open) return; /* nur einmal aufmachen */
  structure_open = 1;
  all_def_type = V_TYPE_A;
  pult_xretval = 0;

  fl_show_form(fd_a_structure->a_structure,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Datenstruktur");
  
  r = a_def[i].db_nr; 
   fl_set_spinner_value(fd_a_structure->db_nr,r);
  r = a_def[i].dw_nr; 
   fl_set_spinner_value(fd_a_structure->dbb_nr,r);
  r = a_def[i].bit_nr; 
   fl_set_counter_value(fd_a_structure->bit_nr,r);
  fl_set_choice(fd_a_structure->format_type,a_def[i].format_type);
  fl_set_input(fd_a_structure->name,a_def[i].name);
}

/* ******************************* */

void cb_a_structure_end (FL_OBJECT *ob, long data)

{
  int i = all_def_idx;

  a_def[i].db_nr = fl_get_spinner_value(fd_a_structure->db_nr);
  a_def[i].dw_nr = fl_get_spinner_value(fd_a_structure->dbb_nr);
  a_def[i].bit_nr = fl_get_counter_value(fd_a_structure->bit_nr);
  a_def[i].format_type = fl_get_choice(fd_a_structure->format_type);
  sstrcpy(a_def[i].name,fl_get_input(fd_a_structure->name),V_NAME_LENGTH);

  set_out(0,i);

  fl_hide_form(fd_a_structure->a_structure);

  structure_open = 0;
  all_def_type = 0;
  recalc_pa_req = 1; /* trigger the re-calculation of pa */
}


/* ******************************* */

/* Ausgangsanalogwerte editieren */
void aw_define(int idx)

{
  FL_OBJECT *obj;

  int i;
  double r;

  all_def_idx = i = idx;
  if (i>=AW_ANZ) return; /* Grenzen pruefen */
  if (structure_open) return; /* nur einmal aufmachen */
  structure_open = 1;
  all_def_type = V_TYPE_AW;
  pult_xretval = 0;

  fl_show_form(fd_aw_structure->aw_structure,FL_PLACE_MOUSE,FL_TRANSIENT,\
     "Datenstruktur");

  r = aw_def[i].db_nr;
   fl_set_spinner_value(fd_aw_structure->db_nr,r);
  r = aw_def[i].dw_nr;
   fl_set_spinner_value(fd_aw_structure->dbb_nr,r);
  fl_set_choice(fd_aw_structure->format_type,aw_def[i].format_type);
  fl_set_input(fd_aw_structure->name,aw_def[i].name);
}

/* ******************************* */

void cb_aw_structure_end (FL_OBJECT *ob, long data)

{
  int i = all_def_idx;

  aw_def[i].db_nr = fl_get_spinner_value(fd_aw_structure->db_nr);
  aw_def[i].dw_nr = fl_get_spinner_value(fd_aw_structure->dbb_nr);
  aw_def[i].format_type = fl_get_choice(fd_aw_structure->format_type);
  sstrcpy(aw_def[i].name,fl_get_input(fd_aw_structure->name),V_NAME_LENGTH);

  set_aw(0,i);

  fl_hide_form(fd_aw_structure->aw_structure);

  structure_open = 0;
  all_def_type = 0;
  recalc_pa_req = 1; /* trigger the re-calculation of pa */
}


/* ******************************* */
/*
   change variable format
*/
void cb_chg_var_format (FL_OBJECT *ob, long data)

{
  int max_anz;
  int short format;
  bit_def_typ *b_ptr;
  eaw_def_typ *w_ptr;

  switch (all_def_type) {
    case V_TYPE_E  : max_anz = E_ANZ;
		     b_ptr = &(e_def[all_def_idx]);
		     break;
    case V_TYPE_EW : max_anz = EW_ANZ;
		     w_ptr = &(ew_def[all_def_idx]);
		     break;
    case V_TYPE_A  : max_anz = A_ANZ;
		     b_ptr = &(a_def[all_def_idx]);
		     break;
    case V_TYPE_AW : max_anz = AW_ANZ;
		     w_ptr = &(aw_def[all_def_idx]);
		     break;
    default        : max_anz = 0;
  }
  if (all_def_idx >= max_anz) return;

  switch (all_def_type) {
    case V_TYPE_E  : b_ptr->format_type = fl_get_choice(fd_e_structure->format_type);
		     break;
    case V_TYPE_A  : b_ptr->format_type = fl_get_choice(fd_a_structure->format_type);
		     break;
    case V_TYPE_EW : w_ptr->format_type = fl_get_choice(fd_ew_structure->format_type);
		     break;
    case V_TYPE_AW : w_ptr->format_type = fl_get_choice(fd_aw_structure->format_type);
		     break;
    default        : break;
  }
}


/* ******************************* */
/*
   delete variable from list
*/
void cb_del_var (FL_OBJECT *ob, long data)

{
  int max_anz;
  int short format;
  bit_def_typ *b_ptr;
  eaw_def_typ *w_ptr;



  switch (all_def_type) {
    case V_TYPE_E  : max_anz = E_ANZ;
		     b_ptr = &(e_def[all_def_idx]);
		     break;
    case V_TYPE_EW : max_anz = EW_ANZ;
		     w_ptr = &(ew_def[all_def_idx]);
		     break;
    case V_TYPE_A  : max_anz = A_ANZ;
		     b_ptr = &(a_def[all_def_idx]);
		     break;
    case V_TYPE_AW : max_anz = AW_ANZ;
		     w_ptr = &(aw_def[all_def_idx]);
		     break;
    default        : max_anz = 0;
  }
  if (all_def_idx >= max_anz) return;

  switch (all_def_type) {
    case V_TYPE_E  :
    case V_TYPE_A  : format = b_ptr->format_type;
		     break;
    case V_TYPE_EW :
    case V_TYPE_AW : format = w_ptr->format_type;
		     break;
    default        : format = 0;
  }

  if (format != INACTIVE) {
    fl_show_messages("The variable needs to be set inactive to be deleted");
    return;
  }

  switch (all_def_type) {
    case V_TYPE_E  :
    case V_TYPE_A  : b_ptr->db_nr = 0;
		     b_ptr->dw_nr = 0;
		     b_ptr->bit_nr = 0;
		     b_ptr->pa_nr = -1;
		     strcpy(b_ptr->name,"X");
	  	     fl_set_spinner_value(fd_e_structure->db_nr,0);
		     fl_set_spinner_value(fd_e_structure->dbb_nr,0);
		     fl_set_counter_value(fd_e_structure->bit_nr,0);
		     fl_set_input(fd_e_structure->name,"X");
	  	     fl_set_spinner_value(fd_a_structure->db_nr,0);
		     fl_set_spinner_value(fd_a_structure->dbb_nr,0);
		     fl_set_counter_value(fd_a_structure->bit_nr,0);
		     fl_set_input(fd_a_structure->name,"X");
		     break;
    case V_TYPE_EW :
    case V_TYPE_AW : w_ptr->db_nr = 0;
		     w_ptr->dw_nr = 0;
		     w_ptr->bit_nr = 0;
		     w_ptr->pa_nr = -1;
		     strcpy(w_ptr->name,"X");
	  	     fl_set_spinner_value(fd_ew_structure->db_nr,0);
		     fl_set_spinner_value(fd_ew_structure->dbb_nr,0);
		     fl_set_input(fd_ew_structure->name,"X");
	  	     fl_set_spinner_value(fd_aw_structure->db_nr,0);
		     fl_set_spinner_value(fd_aw_structure->dbb_nr,0);
		     fl_set_input(fd_aw_structure->name,"X");
		     break;
    default        : max_anz = 0;
  }
}

/* ******************************* */

int hole_filename(char *filename_long, char *filename_short,
    char *extend,char *dir, const char *title)

{
  char hstr[256];

/*   if (akt_dir[0] != NULL) */
  fl_free_dirlist(akt_dir); 
  fl_invalidate_fselector_cache();
  if (fl_show_fselector(title,dir,extend, "") == NULL)
    return -1;
  /* printf("Filename %s\n",fl_get_filename()); */
  strcpy(filename_short,fl_get_filename());
  /* printf("Filename_short %s\n",filename_short); */
  strcpy(dir,fl_get_directory());
  akt_dir = ( FL_Dirlist *) fl_get_dirlist(dir,"*",&akt_dir_len,FALSE); 

  strcpy(filename_long,dir); /* directory */
  strcat(filename_long,"/");
  strcat(filename_long,filename_short);    /* PFAD/filename */
  return 1;
}

/* ******************************* */

void cb_datei(FL_OBJECT *ob, long data)

{
 int wert;
 char hstr[256];
 char *cp;

  wert = fl_get_menu(ob);
  if (cb_debug) printf("cb_datei: %i\n",wert);

  if (wert == 1) { /* neue Struktur erzeugen */
    if (op_mode == OPMODE_RUN) {
       fl_show_message("","not allowed in ONLINE mode","");
       return;
    }
    init_new_struct();
    calc_pa(); /* Prozessabbild-Tabelle anlegen */
  }  
  else if (wert == 2) { /* Struktur-Datei laden */
    if (op_mode != OPMODE_PROG) {
       fl_show_message("","only allowed in PROG mode","");
       return;
    }
    hole_filename(structfi_name,structfi_name_short,"*.stp",struct_dir,"Structure file");
    fl_set_object_label(fd_pult->d_structur,structfi_name);
    init_new_struct();
    struct_defined = lese_structur(structfi_name);
    if (struct_defined == 1 ) {
      fl_set_object_color(fd_pult->d_structur,FL_TOP_BCOL,FL_TOP_BCOL);
      calc_pa(); /* Prozessabbild-Tabelle anlegen */
    } else if  (struct_defined == -1 ) {
      fl_set_object_color(fd_pult->d_structur,FL_RED,FL_RED);
    }
  }
  else if (wert == 3) { /* Struktur-Datei speichern */
    if (op_mode != OPMODE_PROG) {
       fl_show_message("","only allowed in PROG mode","");
       return;
    }
    hole_filename(structfi_name,structfi_name_short,"*.stp",struct_dir,"structure file");
    if (((cp = strstr( structfi_name,".stp")) == NULL)
     || (cp != (&(structfi_name[0]) + strlen(structfi_name) - 4)) ) {
      strcat (structfi_name,".stp");
    }
    fl_set_object_label(fd_pult->d_structur,structfi_name);
    schreibe_structur(structfi_name);
    if (cb_debug) {
      printf("Dir = %s, Anzahl = %i\n",wdir,akt_dir_len);
    }
  }
  else if(wert == 4) {
    if (op_mode != OPMODE_PROG) {
       fl_show_message("","only allowed in PROG mode","");
       return;
    }
    kdo_db_define();
  }
  else if (wert == 5) { /* rc-Filename anwählen */
    hole_filename(rkrc_fi,rkrc_fi_short,"*.rc",rkrc_dir,"rc- file to server");
    fl_set_object_label(fd_pult->rc_file,rkrc_fi);
    // printf("rkrc-dir >>%s<<\n",rkrc_dir);
  }
  else if (wert == 6) {
    /* Verbindung zur Simatic abbauen */
printf("Shutdown ..\n");
//    fl_set_choice(fd_pult->ba,1);
    fl_call_object_callback(fd_pult->tba_pgm);
    if (online != 0)
     simatic_close();

    fl_finish();
    exit (0);
  }
}

/* ******************************* */

void cb_logo(FL_OBJECT *ob, long data)

{
  switch(fl_get_menu(ob)) {
    case 1: version_exec_dt(); break;
    case 2: help_exec_dt();    break;
    case 3: version_exec_en(); break;
    case 4: help_exec_en();    break;
    default: break;
  }
}

/* ******************************* */

void cb_dummy(FL_OBJECT *ob, long data)

{
}


/* ******************************* */

void cb_simatic_type(FL_OBJECT *ob, long data)

{
  if(fl_get_choice(ob) == 1) {
    bytenr_pro_word = 1;
    simatic_type = 5; 
  } else {
    bytenr_pro_word = 2;
    simatic_type = 7;
  }
}

/* ******************************* */

void cb_access_mode(FL_OBJECT *ob, long data)

{
  access_mode = fl_get_choice(ob) - 1;
}


/* ******************************* */

void cb_ba(FL_OBJECT *ob, long data)

{
  op_mode  = data;
  op_mode_old  = 0; // retrigger display
}

/* ******************************* */

void cb_connect(FL_OBJECT *ob, long data)

{
  int state;

  if ( online == 0) {
    fl_set_object_label(ob,"Connecting ..");
    fl_set_object_color(ob,FL_YELLOW,FL_YELLOW);
    simatic_unlink_req = 0;
    printf("simatic_open ..\n"); fflush(stdout);
    state = simatic_open(rkrc_fi);
    display_con_state(state);
  } else {
    fl_set_object_label(ob,"Deconnecting ..");
    fl_set_object_color(ob,FL_YELLOW,FL_YELLOW);
    simatic_unlink_req = 1;
    op_mode = OPMODE_PROG;
    simatic_close();
  }
}


/* ******************************* */

void cb_posit_ew1 (FL_OBJECT *obj, long data)

{
  int col,row,idx;
  double y;
  char hstr[20];


  y =  fl_get_positioner_yvalue(obj);
  idx = y + data;
  if (idx >= EW_ANZ)
    idx = EW_ANZ-1;

//   printf("cb_posit_ew1(): x %f idx %i\n",y,idx);

  if (op_mode == OPMODE_PROG) {
    ew_define(idx);
    calc_pa();
    set_ew(V_DEF,idx);
    fl_set_object_label(fd_pult->disp_text,ew_def[idx].name);
  } else {
    fl_set_object_label(fd_pult->disp_text,ew_def[idx].name);
    sprintf(hstr,"%i",ew_def[idx].db_nr);
    fl_set_object_label(fd_pult->disp_db,hstr);
    sprintf(hstr,"%i",ew_def[idx].dw_nr);
    fl_set_object_label(fd_pult->disp_dw,hstr);

    switch(ew_def[idx].format_type) {
      case KF16 : strcpy(hstr,"INT"); break;
      case KH16 : strcpy(hstr,"WORD"); break; 
      case KY   : strcpy(hstr,"KY"); break; 
      case KM16 : strcpy(hstr,"16#2#.."); break;
      case KT16 : strcpy(hstr,"S5TIME"); break; 
      case KZ16 : strcpy(hstr,"COUNTER"); break;
      case KF32 : strcpy(hstr,"DINT"); break;
      case KH32 : strcpy(hstr,"DWORD"); break;
      case REAL : strcpy(hstr,"REAL"); break;
      case S5KG : strcpy(hstr,"S5-FLOAT"); break;
      case BIT1 : strcpy(hstr,"Set Bit"); break; 
      case BIT0 : strcpy(hstr,"Reset Bit"); break;
      case BITT : strcpy(hstr,"Toggle Bit"); break;
      default : strcpy(hstr,"not defined"); break;
    }
    fl_set_object_label(fd_pult->type,hstr);

    if (fl_mouse_button() == FL_LEFTMOUSE)  /* nur Schreiben bei linker Taste */
      ew_eing(idx); /* neuen Wert einlesen */
  } 
}

/* ******************************* */

void cb_button (FL_OBJECT *ob, long data)

{
  int col,row,idx;
  char hstr[20];
  int kdo_typ; 

  col = data & 0x7;
  row = data>>4;
  idx = (row-1)*8+col;
  /* printf("button: %i row %i col %i index %i\n",data,row,col,idx); */
   if (op_mode == OPMODE_PROG) {
    e_define(idx);  /* define variable to Button */
    set_in(V_DEF,idx);
    fl_set_object_label(fd_pult->disp_text,e_def[idx].name);
  } else {
    fl_set_object_label(fd_pult->disp_text,e_def[idx].name);
    sprintf(hstr,"%i",e_def[idx].db_nr);
    fl_set_object_label(fd_pult->disp_db,hstr);
    sprintf(hstr,"%i.%i",e_def[idx].dw_nr,e_def[idx].bit_nr);
    fl_set_object_label(fd_pult->disp_dw,hstr);

    switch(e_def[idx].format_type) {
      case KF16 : strcpy(hstr,"INT"); break;
      case KH16 : strcpy(hstr,"WORD"); break; 
      case KY   : strcpy(hstr,"KY"); break; 
      case KM16 : strcpy(hstr,"16#2#.."); break;
      case KT16 : strcpy(hstr,"S5TIME"); break; 
      case KZ16 : strcpy(hstr,"COUNTER"); break; 
      case KF32 : strcpy(hstr,"DINT"); break; 
      case KH32 : strcpy(hstr,"DWORD"); break; 
      case REAL : strcpy(hstr,"REAL"); break; 
      case S5KG : strcpy(hstr,"S5-FLOAT"); break; 
      case BIT1 : strcpy(hstr,"Set Bit"); break; 
      case BIT0 : strcpy(hstr,"Reset Bit"); break; 
      case BITT : strcpy(hstr,"Toggle Bit"); break; 
      default : strcpy(hstr,"not defined"); break;
    }
    fl_set_object_label(fd_pult->type,hstr);

    if ((fl_mouse_button() == FL_LEFTMOUSE)  /* nur Schreiben bei linker Taste */
    && (e_def[idx].format_type > 1)){ /* Kommando zusammenbauen */ 
      switch(e_def[idx].format_type) {
        case 2 : kdo_typ = BIT1;  break; /* Set */
        case 3 : kdo_typ = BIT0;  break; /* Reset */
        case 4 : kdo_typ = BITT;  break; /* Toggle */
        default: kdo_typ = 0;
      }
      def_command(e_def[idx].format_type,
         e_def[idx].db_nr,e_def[idx].dw_nr,e_def[idx].bit_nr,0); 
    }
  }
}

/* ******************************* */

void cb_posit_aw (FL_OBJECT *obj, long data)

{
  int col,row,idx;
  double y;
  char hstr[20];


  y =  fl_get_positioner_yvalue(obj);
  idx = y + data;
  if (idx >= AW_ANZ)
    idx = AW_ANZ-1; 

  if (op_mode == OPMODE_PROG) {
    // printf("posit:y %f data %i idx %i\n",y,data,idx);
 
    aw_define(idx);
    calc_pa();
    set_aw(V_DEF,idx);
    fl_set_object_label(fd_pult->disp_text,aw_def[idx].name);
  } else {
    fl_set_object_label(fd_pult->disp_text,aw_def[idx].name);
    sprintf(hstr,"%i",aw_def[idx].db_nr);
    fl_set_object_label(fd_pult->disp_db,hstr);
    sprintf(hstr,"%i",aw_def[idx].dw_nr);
    fl_set_object_label(fd_pult->disp_dw,hstr);

    switch(aw_def[idx].format_type) {
      case KF16 : strcpy(hstr,"INT"); break;
      case KH16 : strcpy(hstr,"WORD"); break; 
      case KY   : strcpy(hstr,"KY"); break; 
      case KM16 : strcpy(hstr,"16#2#.."); break;
      case KT16 : strcpy(hstr,"S5TIME"); break; 
      case KZ16 : strcpy(hstr,"COUNTER"); break; 
      case KF32 : strcpy(hstr,"DINT"); break; 
      case KH32 : strcpy(hstr,"DWORD"); break; 
      case REAL : strcpy(hstr,"REAL"); break; 
      case S5KG : strcpy(hstr,"S5-FLOAT"); break; 
      case BIT1 : strcpy(hstr,"Set Bit"); break; 
      case BIT0 : strcpy(hstr,"Reset Bit"); break; 
      case BITT : strcpy(hstr,"Toggle Bit"); break; 
      default : strcpy(hstr,"not defined"); break;
    }
    fl_set_object_label(fd_pult->type,hstr);

  }
}

/* ******************************* */

void cb_posit_a (FL_OBJECT *obj, long data)

{
  int col,row,idx;
  double x,y;
  char hstr[20];

  y = fl_get_positioner_yvalue(obj);
  x = fl_get_positioner_xvalue(obj);
  row = y;
  if (row > 5)
    row = 5;
  if (x > 7)
    col = x -1;
  else
    col = x;
  if (col > 15)
    col = 15;
  idx = row*16+col;

  if (op_mode == OPMODE_PROG)  {
    a_define(idx);
    calc_pa();
    fl_set_object_label(fd_pult->disp_text,a_def[idx].name);
    set_out(V_DEF,idx);
  } else {
    fl_set_object_label(fd_pult->disp_text,a_def[idx].name);
    sprintf(hstr,"%i",a_def[idx].db_nr);
    fl_set_object_label(fd_pult->disp_db,hstr);
    sprintf(hstr,"%i.%i",a_def[idx].dw_nr,a_def[idx].bit_nr);
    fl_set_object_label(fd_pult->disp_dw,hstr);
    fl_set_object_label(fd_pult->type,"OUTPUT");
  }
}


/* ******************************* */
/*
void cb_freeposit(FL_OBJECT *ob, long data)

{
}
*/

