/* **************************************************************** 

   Hilfsroutinen fuer pult

 (c) Heisch Automatisierungstechnik, Werner Heisch
       hw@heisch.inka.de
       http://sites.inka.de/heisch 

 Stand: 18.02.2009 apsan-bibliothek eingebaut 
        27.01.2009 direkt-ZUgriff eingebaut 
        09.09.2002 Kommando real an S7 repariert
	02.08.2000 HW S7-REAL eingebaut
        15.07.2000 HW Einbau Test


* *****************************************************************
*/


#define cb_debug 0

#include<stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "forms.h"
#include "p2.h"
#include "p2_data.h"
// #include "rk512_client.h"
#include "simatic_link.h"
#include "apsan.h"

// prototyping
void display_con_state(int fstate); // display connection state
void display_pgm_state(int fstate); // display program state


/* ***********Hilfroutinen******************** */

int one_more_word(eaw_def_typ *w)

{
  int word_cnt;

  switch(w->format_type) {
      case KF16 :
      case KH16 :
      case KT16 :
      case KZ16 :
      case BIT1 :
      case BIT0 :
      case BITT : word_cnt = 1; /* Wort */
                  break;
      case KF32 :
      case KH32 :
      case REAL :
      case S5KG : word_cnt = 2; /* DWort */
                  break;
       default  : word_cnt = 1; /* Wort */
                  break;
  }
  word_cnt --; // because always 1 word registered
  return word_cnt;
}


/* ***********Hilfroutinen******************** */
/* eine Prozessvariable E-Bit im PA definieren */
/* Empfangsauftrag fuer Prozesabbild erstellen */
/* pro PA-block werden maximal 64 DW(128) Byte geholt, ggf. wird ein weiterer
   PA-Block angelegt 

   return value = 1 if defined, else 0; 

*/

int calc_pa_e(int nr)

{
  int j;
  signed char done;

  if (e_def[nr].format_type <= 1)  /*Variable definiert */
    return (0);
  done = 0;
  /* Versuch, Parameterzuordnung */
  j = 0; /* PTR in Pa-Array */
  while (( j < pa_anz) && (done == 0)){ /* NZE Grenzen ueberwachen */
    if (pa[j].db_nr == e_def[nr].db_nr) {
      if ( (pa[j].dw_nr >= e_def[nr].dw_nr/bytenr_pro_word) 
      && ((pa[j].dw_end -  e_def[nr].dw_nr/bytenr_pro_word) < 64) ) {
        pa[j].dw_nr = e_def[nr].dw_nr/bytenr_pro_word;
        e_def[nr].pa_nr = j;
        done = 1;
        return (1);
      }
      if  (( done == 0 ) 
      && (pa[j].dw_end <= e_def[nr].dw_nr/bytenr_pro_word)
      && (( e_def[nr].dw_nr/bytenr_pro_word - pa[j].dw_nr) < 64) ) {
        pa[j].dw_end = e_def[nr].dw_nr/bytenr_pro_word;
        e_def[nr].pa_nr = j;
        done = 1;
        return(1);
      }
    }
    j++ ;
  }
  /* neu anlegen */
  if (pa_anz < PA_ANZ) { /* neuen PA-Block Anlegen */
    pa[pa_anz].db_nr = e_def[nr].db_nr;
    pa[pa_anz].dw_nr = e_def[nr].dw_nr/bytenr_pro_word;
    pa[pa_anz].dw_end = e_def[nr].dw_nr/bytenr_pro_word;
    e_def[nr].pa_nr = pa_anz;
    pa_anz++ ;
    done = 1;
    return(1);
  } else { /* Fehlermeldung: PAs alle belegt */
    display_pgm_state(-1); /* max count pa reached */
    printf ("PAs alle belegt: %i\n",pa_anz);
    return (0);
  }
}

/* ***********Hilfroutinen******************** */
/* eine Prozessvariable A-Bit im PA definieren */
/* Empfangsauftrag fuer Prozesabbild erstellen */
/* pro PA-block werden maximal 64 DW(128) Byte geholt, ggf. wird ein weiterer
   PA-Block angelegt 

   return value = 1 if defined, else 0; 

*/

int calc_pa_a(int nr)

{
  int j;
  signed char done;

  if (a_def[nr].format_type <= 1)  /*Variable definiert */
    return (0);
  done = 0;
  /* Versuch, Parameterzuordnung */
  j = 0; /* PTR in Pa-Array */
  while (( j < pa_anz) && (done == 0)){ /* NZE Grenzen ueberwachen */
    if (pa[j].db_nr == a_def[nr].db_nr) {
      if ( (pa[j].dw_nr >= a_def[nr].dw_nr/bytenr_pro_word) 
      && ((pa[j].dw_end -  a_def[nr].dw_nr/bytenr_pro_word) < 64) ) {
        pa[j].dw_nr = a_def[nr].dw_nr/bytenr_pro_word;
        a_def[nr].pa_nr = j;
        done = 1;
        return (1);
      }
      if  (( done == 0 ) 
      && (pa[j].dw_end <= a_def[nr].dw_nr/bytenr_pro_word)
      && (( a_def[nr].dw_nr/bytenr_pro_word - pa[j].dw_nr) < 64) ) {
        pa[j].dw_end = a_def[nr].dw_nr/bytenr_pro_word;
        a_def[nr].pa_nr = j;
        done = 1;
        return(1);
      }
    }  
    j++ ;
  }
  /* neu anlegen */ 
  if (pa_anz < PA_ANZ) { /* neuen PA-Block Anlegen */
    pa[pa_anz].db_nr = a_def[nr].db_nr;
    pa[pa_anz].dw_nr = a_def[nr].dw_nr/bytenr_pro_word;
    pa[pa_anz].dw_end = a_def[nr].dw_nr/bytenr_pro_word;
    a_def[nr].pa_nr = pa_anz;
    pa_anz++ ;
    done = 1;
    return(1);
  } else { /* Fehlermeldung: PAs alle belegt */
    display_pgm_state(-1); /* max count pa reached */
    printf ("PAs alle belegt: %i\n",pa_anz);
    return (0);
  }
}


/* ********************************************* */
/* eine Prozessvariable AW-Bit im PA definieren */
/* Empfangsauftrag fuer Prozesabbild erstellen */
/* pro PA-block werden maximal 64 DW(128) Byte geholt, ggf. wird ein weiterer
   PA-Block angelegt 

   Die Adressen der pa-blöcke werden hier in S5-Worten gerechnet

   return value = 1 if defined, else 0; 

*/

int calc_pa_aw(int nr)

{
  int j;
  int add_words;
  signed char done;

  // check,additional count of words for this variable.
  // additional meens the amount more than 1 word. 
  // i.e. INT -> 0  , DINT -> 1;
  add_words = one_more_word(&(aw_def[nr]));

  if (aw_def[nr].format_type <= 1)  /*Variable definiert */
    return (0);
  done = 0;
  /* Versuch, Parameterzuordnung */
  j = 0; /* PTR in Pa-Array */
  while (( j < pa_anz) && (done == 0)){ /* NZE Grenzen ueberwachen */
    if (pa[j].db_nr == aw_def[nr].db_nr) {
      // try to set it before the existing block
      if ( (pa[j].dw_nr >= aw_def[nr].dw_nr/bytenr_pro_word)
      && ((pa[j].dw_end -  aw_def[nr].dw_nr/bytenr_pro_word) < 61) ) {
        pa[j].dw_nr = aw_def[nr].dw_nr/bytenr_pro_word;
        aw_def[nr].pa_nr = j;
        done = 1;
        return (1);
      }
      // try to set it behind the existing block
      if  (( done == 0 )
      && (pa[j].dw_end <= aw_def[nr].dw_nr/bytenr_pro_word)
      && (( aw_def[nr].dw_nr/bytenr_pro_word - pa[j].dw_nr) < 61) ) {
        pa[j].dw_end = aw_def[nr].dw_nr/bytenr_pro_word + add_words;
        aw_def[nr].pa_nr = j;
        done = 1;
        return(1);
      }
    }
    j++ ;
  }
  /* neu anlegen */ 
  if (pa_anz < PA_ANZ) { /* neuen PA-Block Anlegen */
    pa[pa_anz].db_nr = aw_def[nr].db_nr;
    pa[pa_anz].dw_nr = aw_def[nr].dw_nr/bytenr_pro_word;
    pa[pa_anz].dw_end = aw_def[nr].dw_nr/bytenr_pro_word + add_words;
    aw_def[nr].pa_nr = pa_anz;
    pa_anz++ ;
    done = 1;
    return(1);
  } else { /* Fehlermeldung: PAs alle belegt */
    display_pgm_state(-1); /* max count pa reached */
    printf ("PAs alle belegt: %i\n",pa_anz);
    return (0);
  }
}
 
/* ********************************************* */
/* eine Prozessvariable EW-Bit im PA definieren */
/* Empfangsauftrag fuer Prozesabbild erstellen */
/* pro PA-block werden maximal 64 DW(128) Byte geholt, ggf. wird ein weiterer
   PA-Block angelegt 

   Die Adressen der pa-blöcke werden hier in S5-Worten gerechnet

   return value = 1 if defined, else 0;

*/

int calc_pa_ew(int nr)

{
  int j;
  int add_words;
  signed char done;

  // check,additional count of words for this variable.
  // additional meens the amount more than 1 word. 
  // i.e. INT -> 0  , DINT -> 1;
  add_words = one_more_word(&(ew_def[nr]));

  if (ew_def[nr].format_type <= 1)  /*Variable definiert */
    return (0);
  done = 0;
  /* Versuch, Parameterzuordnung */
  j = 0; /* PTR in Pa-Array */
  while (( j < pa_anz) && (done == 0)){ /* NZE Grenzen ueberwachen */
    if (pa[j].db_nr == ew_def[nr].db_nr) {
      if ( (pa[j].dw_nr >= ew_def[nr].dw_nr/bytenr_pro_word) 
      && ((pa[j].dw_end -  ew_def[nr].dw_nr/bytenr_pro_word) < 61) ) {
        pa[j].dw_nr = ew_def[nr].dw_nr/bytenr_pro_word;
        ew_def[nr].pa_nr = j;
        done = 1;
        return (1);
      }
      if  (( done == 0 ) 
      && (pa[j].dw_end <= ew_def[nr].dw_nr/bytenr_pro_word)
      && (( ew_def[nr].dw_nr/bytenr_pro_word - pa[j].dw_nr) < 61) ) {
        pa[j].dw_end = ew_def[nr].dw_nr/bytenr_pro_word + add_words;
        ew_def[nr].pa_nr = j;
        done = 1;
        return(1);
      }
    }  
    j++ ;
  }
  /* neu anlegen */ 
  if (pa_anz < PA_ANZ) { /* neuen PA-Block Anlegen */
    pa[pa_anz].db_nr = ew_def[nr].db_nr;
    pa[pa_anz].dw_nr = ew_def[nr].dw_nr/bytenr_pro_word;
    pa[pa_anz].dw_end = ew_def[nr].dw_nr/bytenr_pro_word + add_words;
    ew_def[nr].pa_nr = pa_anz;
    pa_anz++ ;
    done = 1;
    return(1);
  } else { /* Fehlermeldung: PAs alle belegt */
    display_pgm_state(-1); /* max count pa reached */
    printf ("PAs alle belegt: %i\n",pa_anz);
    return (0);
  }
}
 

/* ***********Hilfroutinen******************** */
/* Empfangsauftraege fuer Prozesabbild erstellen */
/* pro PA-block werden maximal 64 DW(128) Byte geholt, ggf. wird ein weiterer
   PA-Block angelegt 
*/

void calc_pa (void)

{
  int i,j;
  signed char done;

  for (i=0;i<PA_ANZ;i++) { /* Prozessabbilder loeschen */
    pa[i].db_nr = 0;
    pa[i].dw_nr = 0;
    pa[i].dw_end = 0;
    pa[i].len = 0;
  }
  pa_anz = 0;
    display_pgm_state(-1000); /* Reset error*/

  /* Zuordnung bei Ausgangswerten loeschen */
  for (i=0;i<A_ANZ;i++) /* Prozessabbilder zuordnung loeschen */
    a_def[i].pa_nr = -1;
  for (i=0;i<AW_ANZ;i++) /* Prozessabblider loeschen */
    aw_def[i].pa_nr = -1;
 
  /* AusgangsVariabe einem der Prozessabbilder zuordnen */
  for (i=0;i<A_ANZ;i++)  {
    calc_pa_a(i);
  }
  /* EingangsVariabe einem der Prozessabbilder zuordnen */
  for (i=0;i<E_ANZ;i++)  {
    calc_pa_e(i);
  }
  /* AW-Variabe einem Prozessabbilder zuordnen */
  for (i=0;i<AW_ANZ;i++)  {
    calc_pa_aw(i);
  }
  /* EW-Variabe einem Prozessabbilder zuordnen */
  for (i=0;i<EW_ANZ;i++)  {
    calc_pa_ew(i);
  }
  for (i=0;i<pa_anz;i++)
    pa[i].len = pa[i].dw_end - pa[i].dw_nr +1;
  
  if (cb_debug != 0) {
    printf("Calc_pa : \n");
    for (i=0;i<PA_ANZ;i++)  
      printf(" pa %i: db %i dw %i dw %i len %i\n",i,pa[i].db_nr,pa[i].dw_nr,pa[i].dw_end,pa[i].len);
    printf(" bytes/word: %i \n",bytenr_pro_word);
  }
    display_pgm_state(1); // display cout of used pa
}

/* ******************************* */

void set_w_color(int test, eaw_def_typ stru, FL_OBJECT *ptr,FL_OBJECT *tptr)

{
  int format;
  char hstr[30];
  
  if (stru.format_type > 1) {
    if (test == V_ACTUAL) {
      if (stru.error == 0)
        format = 2;
      else
        format = 3 ; /* error */
    }
    else if (test == V_NEUTRAL)
       format = 1;
    else if (test == V_TEST_OK)
       format = 2;
    else if (test == V_TEST_NOK)
       format = 3;
    else if (test == V_DEF)
       format = 2;
  } else {
       format = 1;
  }

  switch  (format) {
    case 1 : fl_set_object_color(ptr,FL_COL1,FL_COL1);
             break;
    case 2 : fl_set_object_color(ptr,FL_GREEN,FL_GREEN);
             break;
    case 3 : fl_set_object_color(ptr,FL_RED,FL_RED);
             break;
  }
  fl_set_object_label(ptr,stru.cval);
  if (tptr != NULL) {
    fl_set_object_label(tptr,stru.name);
  }
}

/* ******************************* */

void set_ew(int test, int idx)

{
  switch (idx) {
    case  0 : set_w_color(test,ew_def[idx],fd_pult->iw1,fd_pult->tiw1 ); break;
    case  1 : set_w_color(test,ew_def[idx],fd_pult->iw2,fd_pult->tiw2 ); break;
    case  2 : set_w_color(test,ew_def[idx],fd_pult->iw3,fd_pult->tiw3 ); break;
    case  3 : set_w_color(test,ew_def[idx],fd_pult->iw4,fd_pult->tiw4 ); break;
    case  4 : set_w_color(test,ew_def[idx],fd_pult->iw5,fd_pult->tiw5 ); break;
    case  5 : set_w_color(test,ew_def[idx],fd_pult->iw6,fd_pult->tiw6 ); break;
    case  6 : set_w_color(test,ew_def[idx],fd_pult->iw7,fd_pult->tiw7 ); break;
    case  7 : set_w_color(test,ew_def[idx],fd_pult->iw8,fd_pult->tiw8 ); break;
    case  8 : set_w_color(test,ew_def[idx],fd_pult->iw9,fd_pult->tiw9 ); break;
    case  9 : set_w_color(test,ew_def[idx],fd_pult->iw10,fd_pult->tiw10 ); break;
    case 10 : set_w_color(test,ew_def[idx],fd_pult->iw11,fd_pult->tiw11 ); break;
    case 11 : set_w_color(test,ew_def[idx],fd_pult->iw12,fd_pult->tiw12 ); break;
    case 12 : set_w_color(test,ew_def[idx],fd_pult->iw13,fd_pult->tiw13 ); break;
    case 13 : set_w_color(test,ew_def[idx],fd_pult->iw14,fd_pult->tiw14 ); break;
    case 14 : set_w_color(test,ew_def[idx],fd_pult->iw15,fd_pult->tiw15 ); break;
    case 15 : set_w_color(test,ew_def[idx],fd_pult->iw16,fd_pult->tiw16 ); break;
    case 16 : set_w_color(test,ew_def[idx],fd_pult->iw17,fd_pult->tiw17 ); break;
    case 17 : set_w_color(test,ew_def[idx],fd_pult->iw18,fd_pult->tiw18 ); break;
    break;
  }
}

/* ******************************* */

void set_aw(int test, int idx)

{
  switch (idx) {
    case  0 : set_w_color(test,aw_def[idx],fd_pult->ow1,fd_pult->tow1); break;
    case  1 : set_w_color(test,aw_def[idx],fd_pult->ow2,fd_pult->tow2); break;
    case  2 : set_w_color(test,aw_def[idx],fd_pult->ow3,fd_pult->tow3); break;
    case  3 : set_w_color(test,aw_def[idx],fd_pult->ow4,fd_pult->tow4); break;
    case  4 : set_w_color(test,aw_def[idx],fd_pult->ow5,fd_pult->tow5); break;
    case  5 : set_w_color(test,aw_def[idx],fd_pult->ow6,fd_pult->tow6); break;
    case  6 : set_w_color(test,aw_def[idx],fd_pult->ow7,fd_pult->tow7); break;
    case  7 : set_w_color(test,aw_def[idx],fd_pult->ow8,fd_pult->tow8); break;
    case  8 : set_w_color(test,aw_def[idx],fd_pult->ow9,fd_pult->tow9); break;
    case  9 : set_w_color(test,aw_def[idx],fd_pult->ow10,fd_pult->tow10); break;
    case 10 : set_w_color(test,aw_def[idx],fd_pult->ow11,fd_pult->tow11); break;
    case 11 : set_w_color(test,aw_def[idx],fd_pult->ow12,fd_pult->tow12); break;
    case 12 : set_w_color(test,aw_def[idx],fd_pult->ow13,fd_pult->tow13); break;
    case 13 : set_w_color(test,aw_def[idx],fd_pult->ow14,fd_pult->tow14); break;
    case 14 : set_w_color(test,aw_def[idx],fd_pult->ow15,fd_pult->tow15); break;
    case 15 : set_w_color(test,aw_def[idx],fd_pult->ow16,fd_pult->tow16); break;
    case 16 : set_w_color(test,aw_def[idx],fd_pult->ow17,fd_pult->tow17); break;
    case 17 : set_w_color(test,aw_def[idx],fd_pult->ow18,fd_pult->tow18); break;
    break;
  }
}

/* ******************************* */

void set_in_color(int test, bit_def_typ stru, FL_OBJECT *ptr)

{
  int rebuild = 0;
  char hstr[100];

  FL_COLOR col;

  if (stru.format_type == 1) { // not aktive
    col = FL_COL1;
  } else {
    // is active
    if (test == V_NEUTRAL )  col = FL_COL1;/* reset display : neutral schalten */
    else if (test == V_TEST_OK) {/* set OK */
      col = FL_LIGHTER_COL1;
      rebuild = 1;
    } else if (test == V_TEST_NOK) {
      col = FL_RED; /* Set error */
      rebuild = 1;
    } else if (test == V_DEF ) { /* Definition */
     if (stru.format_type > 1) /* according beeing used */
       col = FL_LIGHTER_COL1;
     else
       col = FL_COL1;
    }
    else if (test == V_ACTUAL) {
      if (stru.error == 1) {
         col = FL_RED;
      } else if (stru.val) {
          col = FL_GREEN;
      } else { 
          col = FL_LIGHTER_COL1;
      }
    }
  }
  fl_set_object_color(ptr,col,col);
  if ((test == V_DEF) || (rebuild)) {
   switch (stru.format_type) {
      case BIT1 : strcpy(hstr,"/ "); break;
      case BIT0 : strcpy(hstr,"\\ "); break;
      case BITT : strcpy(hstr,"X "); break;
      default   : strcpy(hstr,"  "); break;
    }
    strcat(hstr,stru.name);
    fl_set_object_label(ptr,hstr);
  }
}

/* ******************************* */

void set_in(int test,int idx)

{
  switch (idx) {
    case  0 : set_in_color(test,e_def[idx],fd_pult->in_1_0); break;
    case  1 : set_in_color(test,e_def[idx],fd_pult->in_1_1); break;
    case  2 : set_in_color(test,e_def[idx],fd_pult->in_1_2); break;
    case  3 : set_in_color(test,e_def[idx],fd_pult->in_1_3); break;
    case  4 : set_in_color(test,e_def[idx],fd_pult->in_1_4); break;
    case  5 : set_in_color(test,e_def[idx],fd_pult->in_1_5); break;
    case  6 : set_in_color(test,e_def[idx],fd_pult->in_1_6); break;
    case  7 : set_in_color(test,e_def[idx],fd_pult->in_1_7); break;
    case  8 : set_in_color(test,e_def[idx],fd_pult->in_2_0); break;
    case  9 : set_in_color(test,e_def[idx],fd_pult->in_2_1); break;
    case 10 : set_in_color(test,e_def[idx],fd_pult->in_2_2); break;
    case 11 : set_in_color(test,e_def[idx],fd_pult->in_2_3); break;
    case 12 : set_in_color(test,e_def[idx],fd_pult->in_2_4); break;
    case 13 : set_in_color(test,e_def[idx],fd_pult->in_2_5); break;
    case 14 : set_in_color(test,e_def[idx],fd_pult->in_2_6); break;
    case 15 : set_in_color(test,e_def[idx],fd_pult->in_2_7); break;
    case 16 : set_in_color(test,e_def[idx],fd_pult->in_3_0); break;
    case 17 : set_in_color(test,e_def[idx],fd_pult->in_3_1); break;
    case 18 : set_in_color(test,e_def[idx],fd_pult->in_3_2); break;
    case 19 : set_in_color(test,e_def[idx],fd_pult->in_3_3); break;
    case 20 : set_in_color(test,e_def[idx],fd_pult->in_3_4); break;
    case 21 : set_in_color(test,e_def[idx],fd_pult->in_3_5); break;
    case 22 : set_in_color(test,e_def[idx],fd_pult->in_3_6); break;
    case 23 : set_in_color(test,e_def[idx],fd_pult->in_3_7); break;
    case 24 : set_in_color(test,e_def[idx],fd_pult->in_4_0); break;
    case 25 : set_in_color(test,e_def[idx],fd_pult->in_4_1); break;
    case 26 : set_in_color(test,e_def[idx],fd_pult->in_4_2); break;
    case 27 : set_in_color(test,e_def[idx],fd_pult->in_4_3); break;
    case 28 : set_in_color(test,e_def[idx],fd_pult->in_4_4); break;
    case 29 : set_in_color(test,e_def[idx],fd_pult->in_4_5); break;
    case 30 : set_in_color(test,e_def[idx],fd_pult->in_4_6); break;
    case 31 : set_in_color(test,e_def[idx],fd_pult->in_4_7); break;
    case 32 : set_in_color(test,e_def[idx],fd_pult->in_5_0); break;
    case 33 : set_in_color(test,e_def[idx],fd_pult->in_5_1); break;
    case 34 : set_in_color(test,e_def[idx],fd_pult->in_5_2); break;
    case 35 : set_in_color(test,e_def[idx],fd_pult->in_5_3); break;
    case 36 : set_in_color(test,e_def[idx],fd_pult->in_5_4); break;
    case 37 : set_in_color(test,e_def[idx],fd_pult->in_5_5); break;
    case 38 : set_in_color(test,e_def[idx],fd_pult->in_5_6); break;
    case 39 : set_in_color(test,e_def[idx],fd_pult->in_5_7); break;
    case 40 : set_in_color(test,e_def[idx],fd_pult->in_6_0); break;
    case 41 : set_in_color(test,e_def[idx],fd_pult->in_6_1); break;
    case 42 : set_in_color(test,e_def[idx],fd_pult->in_6_2); break;
    case 43 : set_in_color(test,e_def[idx],fd_pult->in_6_3); break;
    case 44 : set_in_color(test,e_def[idx],fd_pult->in_6_4); break;
    case 45 : set_in_color(test,e_def[idx],fd_pult->in_6_5); break;
    case 46 : set_in_color(test,e_def[idx],fd_pult->in_6_6); break;
    case 47 : set_in_color(test,e_def[idx],fd_pult->in_6_7); break;
    break;
  }
}

/* ******************************* */

void set_out_color(short test, bit_def_typ stru, FL_OBJECT *ptr)

{
  int val = 2;

 
  if (stru.format_type == 1) { // not aktive
    val = 2; /* neutral */
/*  else if (test){ */ 
  } else {
    if (test == V_NEUTRAL ) val = 2; /* reset display : neutral schalten */
    else if (test == V_TEST_OK)  val = 1; /* set OK */ 
    else if (test == V_TEST_NOK )  val = 5; /* Set error */
    else if (test == V_DEF ) { /* Definition */
     if (stru.format_type > 1) /* according beeing used */
       val = 0;
     else
       val = 2;
    }
    else if (test == V_ACTUAL) {
      if (stru.error == 1) {
        val = 5;
      } else {
        val = stru.val;
      }
    }
  }

  if (val == 1)
    fl_set_object_color(ptr,FL_GREEN,FL_GREEN);
  else if (val == 0)
    fl_set_object_color(ptr,FL_WHITE,FL_WHITE);
  else if (val == 2)
    fl_set_object_color(ptr,FL_COL1,FL_COL1);
  else if (val == 5)
    fl_set_object_color(ptr,FL_RED,FL_RED);
}

/* ******************************* */

void set_out(int test,int idx)

{
  switch (idx) {
    case  0 : set_out_color(test,a_def[idx],fd_pult->bit_0_0); break;
    case  1 : set_out_color(test,a_def[idx],fd_pult->bit_0_1); break;
    case  2 : set_out_color(test,a_def[idx],fd_pult->bit_0_2); break;
    case  3 : set_out_color(test,a_def[idx],fd_pult->bit_0_3); break;
    case  4 : set_out_color(test,a_def[idx],fd_pult->bit_0_4); break;
    case  5 : set_out_color(test,a_def[idx],fd_pult->bit_0_5); break;
    case  6 : set_out_color(test,a_def[idx],fd_pult->bit_0_6); break;
    case  7 : set_out_color(test,a_def[idx],fd_pult->bit_0_7); break;
    case  8 : set_out_color(test,a_def[idx],fd_pult->bit_0_8); break;
    case  9 : set_out_color(test,a_def[idx],fd_pult->bit_0_9); break;
    case 10 : set_out_color(test,a_def[idx],fd_pult->bit_0_10); break;
    case 11 : set_out_color(test,a_def[idx],fd_pult->bit_0_11); break;
    case 12 : set_out_color(test,a_def[idx],fd_pult->bit_0_12); break;
    case 13 : set_out_color(test,a_def[idx],fd_pult->bit_0_13); break;
    case 14 : set_out_color(test,a_def[idx],fd_pult->bit_0_14); break;
    case 15 : set_out_color(test,a_def[idx],fd_pult->bit_0_15); break;
    case 16 : set_out_color(test,a_def[idx],fd_pult->bit_1_0); break;
    case 17 : set_out_color(test,a_def[idx],fd_pult->bit_1_1); break;
    case 18 : set_out_color(test,a_def[idx],fd_pult->bit_1_2); break;
    case 19 : set_out_color(test,a_def[idx],fd_pult->bit_1_3); break;
    case 20 : set_out_color(test,a_def[idx],fd_pult->bit_1_4); break;
    case 21 : set_out_color(test,a_def[idx],fd_pult->bit_1_5); break;
    case 22 : set_out_color(test,a_def[idx],fd_pult->bit_1_6); break;
    case 23 : set_out_color(test,a_def[idx],fd_pult->bit_1_7); break;
    case 24 : set_out_color(test,a_def[idx],fd_pult->bit_1_8); break;
    case 25 : set_out_color(test,a_def[idx],fd_pult->bit_1_9); break;
    case 26 : set_out_color(test,a_def[idx],fd_pult->bit_1_10); break;
    case 27 : set_out_color(test,a_def[idx],fd_pult->bit_1_11); break;
    case 28 : set_out_color(test,a_def[idx],fd_pult->bit_1_12); break;
    case 29 : set_out_color(test,a_def[idx],fd_pult->bit_1_13); break;
    case 30 : set_out_color(test,a_def[idx],fd_pult->bit_1_14); break;
    case 31 : set_out_color(test,a_def[idx],fd_pult->bit_1_15); break;
    case 32 : set_out_color(test,a_def[idx],fd_pult->bit_2_0); break;
    case 33 : set_out_color(test,a_def[idx],fd_pult->bit_2_1); break;
    case 34 : set_out_color(test,a_def[idx],fd_pult->bit_2_2); break;
    case 35 : set_out_color(test,a_def[idx],fd_pult->bit_2_3); break;
    case 36 : set_out_color(test,a_def[idx],fd_pult->bit_2_4); break;
    case 37 : set_out_color(test,a_def[idx],fd_pult->bit_2_5); break;
    case 38 : set_out_color(test,a_def[idx],fd_pult->bit_2_6); break;
    case 39 : set_out_color(test,a_def[idx],fd_pult->bit_2_7); break;
    case 40 : set_out_color(test,a_def[idx],fd_pult->bit_2_8); break;
    case 41 : set_out_color(test,a_def[idx],fd_pult->bit_2_9); break;
    case 42 : set_out_color(test,a_def[idx],fd_pult->bit_2_10); break;
    case 43 : set_out_color(test,a_def[idx],fd_pult->bit_2_11); break;
    case 44 : set_out_color(test,a_def[idx],fd_pult->bit_2_12); break;
    case 45 : set_out_color(test,a_def[idx],fd_pult->bit_2_13); break;
    case 46 : set_out_color(test,a_def[idx],fd_pult->bit_2_14); break;
    case 47 : set_out_color(test,a_def[idx],fd_pult->bit_2_15); break;
    case 48 : set_out_color(test,a_def[idx],fd_pult->bit_3_0); break;
    case 49 : set_out_color(test,a_def[idx],fd_pult->bit_3_1); break;
    case 50 : set_out_color(test,a_def[idx],fd_pult->bit_3_2); break;
    case 51 : set_out_color(test,a_def[idx],fd_pult->bit_3_3); break;
    case 52 : set_out_color(test,a_def[idx],fd_pult->bit_3_4); break;
    case 53 : set_out_color(test,a_def[idx],fd_pult->bit_3_5); break;
    case 54 : set_out_color(test,a_def[idx],fd_pult->bit_3_6); break;
    case 55 : set_out_color(test,a_def[idx],fd_pult->bit_3_7); break;
    case 56 : set_out_color(test,a_def[idx],fd_pult->bit_3_8); break;
    case 57 : set_out_color(test,a_def[idx],fd_pult->bit_3_9); break;
    case 58 : set_out_color(test,a_def[idx],fd_pult->bit_3_10); break;
    case 59 : set_out_color(test,a_def[idx],fd_pult->bit_3_11); break;
    case 60 : set_out_color(test,a_def[idx],fd_pult->bit_3_12); break;
    case 61 : set_out_color(test,a_def[idx],fd_pult->bit_3_13); break;
    case 62 : set_out_color(test,a_def[idx],fd_pult->bit_3_14); break;
    case 63 : set_out_color(test,a_def[idx],fd_pult->bit_3_15); break;
    case 64 : set_out_color(test,a_def[idx],fd_pult->bit_4_0); break;
    case 65 : set_out_color(test,a_def[idx],fd_pult->bit_4_1); break;
    case 66 : set_out_color(test,a_def[idx],fd_pult->bit_4_2); break;
    case 67 : set_out_color(test,a_def[idx],fd_pult->bit_4_3); break;
    case 68 : set_out_color(test,a_def[idx],fd_pult->bit_4_4); break;
    case 69 : set_out_color(test,a_def[idx],fd_pult->bit_4_5); break;
    case 70 : set_out_color(test,a_def[idx],fd_pult->bit_4_6); break;
    case 71 : set_out_color(test,a_def[idx],fd_pult->bit_4_7); break;
    case 72 : set_out_color(test,a_def[idx],fd_pult->bit_4_8); break;
    case 73 : set_out_color(test,a_def[idx],fd_pult->bit_4_9); break;
    case 74 : set_out_color(test,a_def[idx],fd_pult->bit_4_10); break;
    case 75 : set_out_color(test,a_def[idx],fd_pult->bit_4_11); break;
    case 76 : set_out_color(test,a_def[idx],fd_pult->bit_4_12); break;
    case 77 : set_out_color(test,a_def[idx],fd_pult->bit_4_13); break;
    case 78 : set_out_color(test,a_def[idx],fd_pult->bit_4_14); break;
    case 79 : set_out_color(test,a_def[idx],fd_pult->bit_4_15); break;
    case 80 : set_out_color(test,a_def[idx],fd_pult->bit_5_0); break;
    case 81 : set_out_color(test,a_def[idx],fd_pult->bit_5_1); break;
    case 82 : set_out_color(test,a_def[idx],fd_pult->bit_5_2); break;
    case 83 : set_out_color(test,a_def[idx],fd_pult->bit_5_3); break;
    case 84 : set_out_color(test,a_def[idx],fd_pult->bit_5_4); break;
    case 85 : set_out_color(test,a_def[idx],fd_pult->bit_5_5); break;
    case 86 : set_out_color(test,a_def[idx],fd_pult->bit_5_6); break;
    case 87 : set_out_color(test,a_def[idx],fd_pult->bit_5_7); break;
    case 88 : set_out_color(test,a_def[idx],fd_pult->bit_5_8); break;
    case 89 : set_out_color(test,a_def[idx],fd_pult->bit_5_9); break;
    case 90 : set_out_color(test,a_def[idx],fd_pult->bit_5_10); break;
    case 91 : set_out_color(test,a_def[idx],fd_pult->bit_5_11); break;
    case 92 : set_out_color(test,a_def[idx],fd_pult->bit_5_12); break;
    case 93 : set_out_color(test,a_def[idx],fd_pult->bit_5_13); break;
    case 94 : set_out_color(test,a_def[idx],fd_pult->bit_5_14); break;
    case 95 : set_out_color(test,a_def[idx],fd_pult->bit_5_15); break;
    default : break;
  }

}

/* ******************************* */
/* Ausgabe der beteiligten Daten 
if error, the error = 1 else 0
*/
void output(int error,int pnr)

{
  int i, idx;
  short word;
  int shft;
  double dval;
  int retval;

   for (i=0;i< E_ANZ; i++) {
    if (e_def[i].pa_nr == pnr) {
      idx = ( e_def[i].dw_nr - pa[pnr].dw_nr * bytenr_pro_word ) \
           / bytenr_pro_word ;
      if (simatic_type == 5) {
        word = get_dw(&pa[pnr].dw[idx]);
        e_def[i].val = 1&(word>>a_def[i].bit_nr);
      } else {
        word = pa[pnr].dw[idx];
        shft = a_def[i].dw_nr % 2;
        e_def[i].val = 1&(word>>(e_def[i].bit_nr +shft*8));
      }
      e_def[i].error = error;
      set_in(V_ACTUAL,i);		/* Bildschirm aktualisieren: Bit-Eingänge */
    }
  }
   for (i=0;i< A_ANZ; i++) {
    if (a_def[i].pa_nr == pnr) {
      idx = ( a_def[i].dw_nr - pa[pnr].dw_nr * bytenr_pro_word ) \
           / bytenr_pro_word ;
      if (simatic_type == 5) {
        word = get_dw(&pa[pnr].dw[idx]);
        a_def[i].val = 1&(word>>a_def[i].bit_nr);
      } else {
        word = pa[pnr].dw[idx];
        shft = a_def[i].dw_nr % 2;
        a_def[i].val = 1&(word>>(a_def[i].bit_nr +shft*8));
      }
      a_def[i].error = error;
      set_out(V_ACTUAL,i);		/* Bildschirm aktualisieren: Bit-Ausgaenge */
    }
  }
  for (i=0;i< AW_ANZ; i++) {
    if (aw_def[i].pa_nr == pnr) {
      idx = ( aw_def[i].dw_nr - pa[pnr].dw_nr * bytenr_pro_word ) \
        / bytenr_pro_word ;
      switch (aw_def[i].format_type) {
        case KF16  : sprintf(aw_def[i].cval,"KF %7i",\
                     aw_def[i].lval = get_dw_kf(&(pa[pnr].dw[idx]))); 
                     break;
        case KH16  :
        case KM16  : sprintf(aw_def[i].cval,"KH %04lx",\
                     aw_def[i].lval = get_dw(&(pa[pnr].dw[idx]))); 
                     break;
        case KY    : sprintf(aw_def[i].cval,"%0i,%i",\
                     aw_def[i].lval = get_dl(&(pa[pnr].dw[idx])),
                     aw_def[i].lval = get_dr(&(pa[pnr].dw[idx])));
                     break;

        case KT16  : sprintf(aw_def[i].cval,"KT %8.2f s",\
                     aw_def[i].lval = get_kt(&(pa[pnr].dw[idx]))/1000.0); 
                     break; 
        case KZ16  : sprintf(aw_def[i].cval,"KZ %7i",\
                     aw_def[i].lval = get_kz(&(pa[pnr].dw[idx]))); 
                     break;
        case KF32  : sprintf(aw_def[i].cval,"KF %11i",\
                     aw_def[i].lval = get_dd_kf(&(pa[pnr].dw[idx]))); 
                     break;
        case KH32  : sprintf(aw_def[i].cval,"KH %08lx",\
                     aw_def[i].lval = get_dd(&(pa[pnr].dw[idx]))); 
                     break;
        case REAL  : retval = get_real(&dval,&(pa[pnr].dw[idx]));
                     if (retval == 0)
                       sprintf(aw_def[i].cval,"%13g",dval);
                     else
                       sprintf(aw_def[i].cval,"KH %08lx",\
                       get_dd(&(pa[pnr].dw[idx]))); 
                     break;
        case S5KG  : retval = get_s5kg(&dval,&(pa[pnr].dw[idx]));
                     if (retval == 0)
                       sprintf(aw_def[i].cval,"%13g",dval);
                     else
                       sprintf(aw_def[i].cval,"KH %08lx",\
                       get_dd(&(pa[pnr].dw[idx]))); 
                     break;
        default :    sprintf(aw_def[i].cval,"--"); break;
      }
      aw_def[i].error = error;
      set_aw(V_ACTUAL,i);		/* Bildschirm aktualisieren: Wort/Dwort-Ausgaenge */
    }
  }
  for (i=0;i< EW_ANZ; i++) {
    if (ew_def[i].pa_nr == pnr) {
      idx = ( ew_def[i].dw_nr - pa[pnr].dw_nr * bytenr_pro_word ) \
        / bytenr_pro_word ;
      switch (ew_def[i].format_type) {
        case KF16  : sprintf(ew_def[i].cval,"KF %7i",\
                     (ew_def[i].lval = get_dw_kf(&pa[pnr].dw[idx])));
                     break;
        case KH16  :
        case KM16  : sprintf(ew_def[i].cval,"KH %04lx",\
                     (ew_def[i].lval = get_dw(&pa[pnr].dw[idx])));
                     break;
        case KY    : sprintf(ew_def[i].cval,"%0i,%i",\
                     ew_def[i].lval = get_dl(&(pa[pnr].dw[idx])),
                     ew_def[i].lval = get_dr(&(pa[pnr].dw[idx])));
                     break;
        case KT16  : sprintf(ew_def[i].cval,"KT %8.2f s",\
                     (ew_def[i].val = get_kt(&pa[pnr].dw[idx])/1000.0)); 
                     break; 
        case KZ16  : sprintf(ew_def[i].cval,"KZ %7i",\
                     (ew_def[i].lval = get_kz(&pa[pnr].dw[idx])));
                     break;
        case KF32  : sprintf(ew_def[i].cval,"KF %11i",\
                     (ew_def[i].lval = get_dd_kf(&(pa[pnr].dw[idx])))); 
                     break;
        case KH32  : sprintf(ew_def[i].cval,"KH %08lx",\
                     (ew_def[i].lval = get_dd(&(pa[pnr].dw[idx])))); 
                     break;
        case REAL  : retval = get_real(&dval,&(pa[pnr].dw[idx]));
                     if (retval == 0)
                       sprintf(ew_def[i].cval,"%13g",dval);
                     else
                       sprintf(ew_def[i].cval,"KH %08lx",\
                       get_dd(&(pa[pnr].dw[idx]))); 
                     break;
        case S5KG  : retval = get_s5kg(&dval,&(pa[pnr].dw[idx]));
                     if (retval == 0)
                       sprintf(ew_def[i].cval,"%13g",dval);
                     else
                       sprintf(ew_def[i].cval,"KH %08lx",\
                       get_dd(&(pa[pnr].dw[idx])));
                     break;
        default :    sprintf(ew_def[i].cval,"--"); break;
    }
      ew_def[i].error = error;
      set_ew(V_ACTUAL,i); /* Bildschirm aktualisieren: Wort/Dwort-Eingaenge */
    }
  }
}

/* ******************************* */
/* test of all in-/output-variables  if accessible */

void test_output( void)

{

 static int pa_idx;
 static int fetch_result;

 int i;

 switch (test_stp) {
   case 0      : /* Reset */
                 pa_idx = 0;
                 fl_set_object_color(fd_pult->tba_test,FL_GREEN,FL_GREEN);
                 fl_set_object_color(fd_pult->tba_pgm,FL_COL1,FL_COL1);
                 fl_set_object_color(fd_pult->tba_run,FL_COL1,FL_COL1);
                 for (i=0;i<PA_ANZ;i++) { /* Prozessabbilder loeschen */
                   pa[i].db_nr = 0;
                   pa[i].dw_nr = 0;
                   pa[i].dw_end = 0;
                   pa[i].len = 0;
                 }
                 pa_anz = 0;
                 for (i=0;i<E_ANZ;i++) {/* Prozessabbilder zuordnung loeschen */
                   set_in(V_NEUTRAL,i);        /* Display neutral schalten */
                   e_def[i].pa_nr = -1;
                 }
                 for (i=0;i<A_ANZ;i++) {/* Prozessabbilder zuordnung loeschen */
                   set_out(V_NEUTRAL,i);        /* Display neutral schalten */
                   a_def[i].pa_nr = -1;
                 }
                 for (i=0;i<AW_ANZ;i++) { /* Prozessabblider loeschen */
                   set_aw(V_NEUTRAL,i); 
                   aw_def[i].pa_nr = -1;
                 }
                 for (i=0;i<EW_ANZ;i++) { /* Prozessabblider loeschen */
                   set_ew(V_NEUTRAL,i);
                   ew_def[i].pa_nr = -1;
                 }
                 test_stp = 1;
                 break;
   case 1:       // Prozessabbilder aufbauen
                 calc_pa();
                 pa_idx = 0;
                 test_stp = 2;
                 if (pa_idx > pa_anz) test_stp = -1;
                 break;
   case 2:       // start reading this pa
                 /* fetch for Test-mode  fetch pa.. data */
		 printf("test_output() pa_idx = %i,DB%i.DBb%i len %i\n",
		       pa_idx,pa[pa_idx].db_nr,pa[pa_idx].dw_nr,pa[pa_idx].len);
                 fetch_result = fetch_start( (void *)pa[pa_idx].dw,'D', \
            		pa[pa_idx].db_nr,pa[pa_idx].dw_nr,pa[pa_idx].len,cpu_nr);
    		 test_stp = 3;
                 break;
   case 3:       rk_error = fetch_result = fetch_ready();
   		 printf("test_output() pa_idx = %i,result %i\n",
		       pa_idx,fetch_result);
 
                 if ((fetch_result < 0 ) || (fetch_result >= 1 ) ) {
    		   display_con_state(rk_error); // display connection state
		   test_stp = 4;
		 }
                 break;
   case 4:       /* Data received or Not */
                 for (i = 0; i< E_ANZ; i++)  { /* Bit Input */
		   if (e_def[i].pa_nr == pa_idx) {
		     if (fetch_result > 0)
			set_in(V_TEST_OK,i);
		     else
			set_in(V_TEST_NOK,i);
		   }
		 }
                 for (i = 0; i< A_ANZ; i++) { /* Bit Output */
		   if (a_def[i].pa_nr == pa_idx) {
		     if (fetch_result > 0)
			set_out(V_TEST_OK,i);
		     else
			set_out(V_TEST_NOK,i);
		   }
                 }
                 for (i = 0; i< EW_ANZ; i++)  { /* Word Input */
		   if (ew_def[i].pa_nr == pa_idx) {
		     if (fetch_result > 0)
			set_ew(V_TEST_OK,i);
		     else
			set_ew(V_TEST_NOK,i);
		   }
		 }
                 for (i = 0; i< AW_ANZ; i++)  {  /* Word Output */
		   if (aw_def[i].pa_nr == pa_idx) {
		     if (fetch_result > 0)
			set_aw(V_TEST_OK,i);
		     else
			set_aw(V_TEST_NOK,i);
		   }
		 }
                 if (pa_idx < pa_anz - 1) {
                   pa_idx++ ;
                   test_stp = 2;
                 } else {
                   test_stp = -1;
                 } 
                 break;

   case -1 :     op_mode = OPMODE_PROG;
//                 fl_set_object_color(fd_pult->tba_test,FL_COL1,FL_COL1);
//                 fl_set_button(fd_pult->tba_pgm,1);
//                 fl_set_object_color(fd_pult->tba_pgm,FL_GREEN,FL_GREEN);
//                 fl_call_object_callback(fd_pult->tba_pgm);
                 break;
   default:      break;
 }
}

/* ******************************* */

void reset_bit_struct(bit_def_typ *stru)

{
  strcpy(stru->name,"Button");         	/* Name */
  stru->pa_nr = -1;                     /* PA-Nr = nicht definiert */ 
  stru->db_nr = 2;         		/* Datenbausteinummer */
  stru->dw_nr = 0;         		/* Wortnummer */
  stru->bit_nr = 0;                     /* Bit-Nr */
  stru->format_type = 1;                /* undefiniert  = 1 */
  stru->error = 0;                  /* kein fehler */
  stru->val = 0;
}

/* ******************************* */

void reset_w_struct(eaw_def_typ *stru)

{
  strcpy(stru->name,"X");         	/* Name */ 
  stru->pa_nr = -1;                     /* PA-Nr = nicht definiert */ 
  stru->db_nr = 2;         		/* Datenbausteinummer */
  stru->dw_nr = 0;         		/* Wortnummer */
  stru->format_type = 1;                 /* undefiniert = 1 */
  stru->error = 0;                  /* kein fehler */
  stru->lval = 0;
  stru->val = 0.0;
}

/* ******************************* */

void init_new_struct()

{
  int i;
  
  for (i = 0; i < E_ANZ; i++) {
    reset_bit_struct(&(e_def[i]));
//    set_in(V_DEF,i);
    set_in(V_NEUTRAL,i);
  }

  for (i = 0; i < A_ANZ; i++) {
    reset_bit_struct(&(a_def[i]));
    set_out(V_NEUTRAL,i);
  }  

  for (i = 0; i < EW_ANZ; i++) {
    reset_w_struct(&(ew_def[i]));
    set_ew(V_NEUTRAL,i);
  }  

  for (i = 0; i < AW_ANZ; i++) {
    reset_w_struct(&(aw_def[i]));
    set_aw(V_NEUTRAL,i);
  }  
}

/* ******************************* */
/* blancs durch '_' ersetzen und Laenge auf 18 begrenzen */
char *name_trans(char *c)

{
  char *anf = c;
  int i = 0;

  while (( *c != '\0' ) && ( i < 18)) {
    if ( *c != ' ') 
      c++ ;
     else 
      *c++ = '_'; 
     i++;
  }
return(anf);
}

/* ******************************* */

void schreibe_structur_alt(char *finame)

{
  int i;

  if ((str_fi = fopen(finame,"w+")) != NULL ) {
    fprintf(str_fi,"%i\n",simatic_type); /* Simatic-typ (s5/S7) */
    fprintf(str_fi,"%i %i %i\n",kdo_dbnr,kdo_dwnr,cpu_nr); /* Kommando-DB,DW */
    for (i=0;i<EW_ANZ;i++) {
      fprintf(str_fi,"%i ",ew_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",ew_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",ew_def[i].format_type);	/* */
      fprintf(str_fi,"%i ",0);	/* */
      fprintf(str_fi,"%d ",0.0);	/* */
      fprintf(str_fi,"%s",name_trans(ew_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    for (i=0;i<AW_ANZ;i++) {
      fprintf(str_fi,"%i ",aw_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",aw_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",aw_def[i].format_type);	/* */
      fprintf(str_fi,"%i ", 0);	/* */
      fprintf(str_fi,"%d ", 0.0);	/* */
      fprintf(str_fi,"%s",name_trans(aw_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    for (i=0;i<E_ANZ;i++) {
      fprintf(str_fi,"%i ",e_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",e_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",e_def[i].bit_nr);	/* */
      fprintf(str_fi,"%i ",e_def[i].format_type);	/* */
      fprintf(str_fi,"%i ", 0);	/* */
      fprintf(str_fi,"%s",name_trans(e_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    for (i=0;i<A_ANZ;i++) {
      fprintf(str_fi,"%i ",a_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",a_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",a_def[i].bit_nr);	/* */
      fprintf(str_fi,"%i ",a_def[i].format_type);	/* */
      fprintf(str_fi,"%i ", 0 );	/* */
      fprintf(str_fi,"%s",name_trans(a_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    fclose(str_fi);
  }
}

/* ******************************* */

void schreibe_structur(char *finame)

{
  int i;
  char hstr[10];

  if ((str_fi = fopen(finame,"w+")) != NULL ) {
    fprintf(str_fi,"PULT_2\n"); /* Typ der Pult-Software */
    if(simatic_type == 5) strcpy(hstr,"S5"); else strcpy(hstr,"S7");
    fprintf(str_fi,"SIMATIC_TYPE %s\n",hstr); /* Kommando-DB,DW */
    fprintf(str_fi,"KDO_DB %i %i\n",kdo_dbnr,kdo_dwnr); /* Kommando-DB,DW */
    fprintf(str_fi,"CPU_NR %i\n",cpu_nr); /* Kommando-DB,DW */
    if (access_mode == 0)
      fprintf(str_fi,"ACCESS DB\n"); /* access over cmd-DB */
    else
      fprintf(str_fi,"ACCESS DIRECT\n"); /* access direct */
    fprintf(str_fi,"RC_FILE %s\n",rkrc_fi); /* rc-file zu server */
    for (i=0;i<EW_ANZ;i++) {
      fprintf(str_fi,"EW %i ",i);	/* */
      fprintf(str_fi,"%i ",ew_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",ew_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",ew_def[i].format_type);	/* */
      fprintf(str_fi,"%i ",0);	/* */
      fprintf(str_fi,"%d ",0.0);	/* */
      fprintf(str_fi,"%s",name_trans(ew_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    for (i=0;i<AW_ANZ;i++) {
      fprintf(str_fi,"AW %i ",i);	/* */
      fprintf(str_fi,"%i ",aw_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",aw_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",aw_def[i].format_type);	/* */
      fprintf(str_fi,"%i ", 0);	/* */
      fprintf(str_fi,"%d ", 0.0);	/* */
      fprintf(str_fi,"%s",name_trans(aw_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    for (i=0;i<E_ANZ;i++) {
      fprintf(str_fi,"Ebit %i ",i);	/* */
      fprintf(str_fi,"%i ",e_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",e_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",e_def[i].bit_nr);	/* */
      fprintf(str_fi,"%i ",e_def[i].format_type);	/* */
      fprintf(str_fi,"%i ", 0);	/* */
      fprintf(str_fi,"%s",name_trans(e_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    for (i=0;i<A_ANZ;i++) {
      fprintf(str_fi,"Abit %i ",i);	/* */
      fprintf(str_fi,"%i ",a_def[i].db_nr);	/* */
      fprintf(str_fi,"%i ",a_def[i].dw_nr);	/* */
      fprintf(str_fi,"%i ",a_def[i].bit_nr);	/* */
      fprintf(str_fi,"%i ",a_def[i].format_type);	/* */
      fprintf(str_fi,"%i ", 0 );	/* */
      fprintf(str_fi,"%s",name_trans(a_def[i].name));	/* */
      fprintf(str_fi,"\n");
    }
    fclose(str_fi);
  }
}


/* ******************************* */

int lese_structur_alt(char *finame)

{
  int i;

  if ((str_fi = fopen(finame,"r")) != NULL ) {
    fscanf(str_fi,"%i",&simatic_type); /* Simatic-typ (s5/S7 ) */
    if ( simatic_type == 5) {
      i = 1; 
      bytenr_pro_word = 1;
    } else {
      i = 2;
      bytenr_pro_word = 2;
    }
    fscanf(str_fi,"%i %i %i",&kdo_dbnr,&kdo_dwnr,&cpu_nr);

    for (i=0;i<EW_ANZ;i++) {
      fscanf(str_fi,"%i",&ew_def[i].db_nr); 
      fscanf(str_fi,"%i",&ew_def[i].dw_nr); 
      fscanf(str_fi,"%i",&ew_def[i].format_type); 
      fscanf(str_fi,"%i",&ew_def[i].lval); 
      fscanf(str_fi,"%d",&ew_def[i].val); 
      fscanf(str_fi,"%s",ew_def[i].name);
      set_ew(V_DEF,i);
    }

    for (i=0;i<AW_ANZ;i++) {
      fscanf(str_fi,"%i",&aw_def[i].db_nr); 
      fscanf(str_fi,"%i",&aw_def[i].dw_nr); 
      fscanf(str_fi,"%i",&aw_def[i].format_type); 
      fscanf(str_fi,"%i",&aw_def[i].lval); 
      fscanf(str_fi,"%d",&aw_def[i].val); 
      fscanf(str_fi,"%s",aw_def[i].name); 
      set_aw(V_DEF,i);
    }
    for (i=0;i<E_ANZ;i++) {
      fscanf(str_fi,"%i",&e_def[i].db_nr); 
      fscanf(str_fi,"%i",&e_def[i].dw_nr); 
      fscanf(str_fi,"%i",&e_def[i].bit_nr); 
      fscanf(str_fi,"%i",&e_def[i].format_type); 
      fscanf(str_fi,"%i",&e_def[i].val); 
      fscanf(str_fi,"%s",e_def[i].name); 
      set_in(V_DEF,i);
    }
   for (i=0;i<A_ANZ;i++) {
      fscanf(str_fi,"%i",&a_def[i].db_nr); 
      fscanf(str_fi,"%i",&a_def[i].dw_nr); 
      fscanf(str_fi,"%i",&a_def[i].bit_nr); 
      fscanf(str_fi,"%i",&a_def[i].format_type); 
      fscanf(str_fi,"%i",&a_def[i].val); 
      fscanf(str_fi,"%s",a_def[i].name); 
      set_out(V_DEF,i);
    }
 printf("A\n"); fflush(stdout);
    fclose(str_fi);
    return 1;
  } else {
    return -1;
  }
}

/* ******************************* */

int lese_structur(char *finame)

{
  int i,j;
  char inbuf[1000];
  char hstr[1000];
  APSAN_P s;
  apsan_result_p erg;

  Apsan_def_id gtok[30] = {
   1001,"PULT_2",
   1002,"SIMATIC_TYPE",
   1003,"KDO_DB",
   1004,"ACCESS",
   1005,"CPU_NR",
   1006,"RC_FILE",
   1011,"EW",
   1012,"AW",
   1013,"Ebit",
   1014,"Abit",
   1020,"S5",
   1021,"S7",
   1022,"DIRECT",
   1023,"DB",
   1030, ":isint:",
   1040,"#*" /* comment */
  };

  /* generate structure for scanned input */
  if (apsan_gen(&s,1000,10,10,10,30,1) != 0) {
    printf("error apsan_gen()\n"); fflush(stdout); }
  /* define the global separators */
  if (apsan_def(s,APSAN_GSEP,0," \t\n") != 0) {
    printf("error apsan_def()\n"); fflush(stdout); }
  /* define the scanning tokens in SSEP */
  if (apsan_def_id(s,APSAN_SSEP,0,gtok,16)  != 0) {
    printf("error apsan_def_id()\n"); fflush(stdout); }
  /* check, if fle ist from type P2 or older */
  if ((str_fi = fopen(finame,"r")) == NULL ) {
    apsan_end(s);
    return -1;
  }

  init_new_struct();  /* Initialisiere Definitionsstruktur */

  /*check, if type P2 */ 
  fgets(inbuf,sizeof inbuf,str_fi);
  apsan_scan(s,APSAN_SSEP,0,inbuf);
  erg = apsan_result(s);

  if ((erg->cnt <= 0) ||(erg->r[0].id != 1001)) { /* not a P2-Type, try with old format */
    apsan_end(s);
    fclose(str_fi);
    return lese_structur_alt(finame);
  }

  /* a P2 type is found , read until end of file */
  while (fgets(inbuf,sizeof inbuf,str_fi) != NULL) {
    if ( apsan_scan(s,APSAN_TOKEN | APSAN_SSEP,0,inbuf) < 0)
      printf("error apsan_gen()\n");
    if (erg->cnt = 0) continue;

    switch(erg->r[0].id) {
     case 1002: /* Simatic type S5, S7 */
                if(erg->r[1].id == 1020) {
                  bytenr_pro_word = 1;
                  simatic_type = 5; /* ist S5 */
                } else {
                  bytenr_pro_word = 2;
                  simatic_type = 7; /* ist S7 */
                }
                break;
     case 1003: /* Command -db, DW */
                if (erg->r[1].id == 1030) {
                  kdo_dbnr = atoi(apsan_rTok(s,hstr,1));
                }
                if (erg->r[2].id == 1030) {
                  kdo_dwnr = atoi(apsan_rTok(s,hstr,2));
                }
                break;
     case 1004: /* ACCESS TYPE */
                if (erg->r[1].id == 1022) {
                  access_mode = 1; /* direct */
                } else {
                  access_mode = 0; /* over cmd-db */
                }
                break;
     case 1005: /* CPU-Nr */
                if (erg->r[1].id == 1030) {
                  cpu_nr = atoi(apsan_rTok(s,hstr,1));
                }
                break;
     case 1006: /* rc-file */
                apsan_rTok(s,rkrc_fi,1);
                fl_set_object_label(fd_pult->rc_file,rkrc_fi);
                rc_defined = 1;
                break;
     case 1011: /* EW */
                if (erg->r[1].id == 1030) {
                  i = atoi(apsan_rTok(s,hstr,1));
                  if (( i >= 0) && (i<EW_ANZ)) {
                    ew_def[i].db_nr = atoi(apsan_rTok(s,hstr,2));
                    ew_def[i].dw_nr = atoi(apsan_rTok(s,hstr,3));
                    ew_def[i].format_type 
                               = atoi(apsan_rTok(s,hstr,4));
                    ew_def[i].lval = atoi(apsan_rTok(s,hstr,5));
                    ew_def[i].val = atof(apsan_rTok(s,hstr,6));
                    apsan_rTok(s,ew_def[i].name,7);
                    set_ew(V_DEF,i);
                  }
                }
                break;
     case 1012: /* AW */
                if (erg->r[1].id == 1030) {
                  i = atoi(apsan_rTok(s,hstr,1));
                  if (( i >= 0) && (i<AW_ANZ)) {
                    aw_def[i].db_nr = atoi(apsan_rTok(s,hstr,2));
                    aw_def[i].dw_nr = atoi(apsan_rTok(s,hstr,3));
                    aw_def[i].format_type 
                               = atoi(apsan_rTok(s,hstr,4));
                    aw_def[i].lval = atoi(apsan_rTok(s,hstr,5));
                    aw_def[i].val = atof(apsan_rTok(s,hstr,6));
                    apsan_rTok(s,aw_def[i].name,7);
                    set_aw(V_DEF,i);
                  }
                }
                break;
     case 1013: /* E-Bit */
                if (erg->r[1].id == 1030) {
                  i = atoi(apsan_rTok(s,hstr,1));
                  if (( i >= 0) && (i<E_ANZ)) {
                    e_def[i].db_nr = atoi(apsan_rTok(s,hstr,2));
                    e_def[i].dw_nr = atoi(apsan_rTok(s,hstr,3));
                    e_def[i].bit_nr = atoi(apsan_rTok(s,hstr,4));
                    e_def[i].format_type = atoi(apsan_rTok(s,hstr,5));
                    /* 6 not used */
                    apsan_rTok(s,e_def[i].name,7);
                    set_in(V_DEF,i);
                  }
                }
                break;
    case 1014: /* A-Bit */
                if (erg->r[1].id == 1030) {
                  i = atoi(apsan_rTok(s,hstr,1));
                  if (( i >= 0) && (i<A_ANZ)) {
                    a_def[i].db_nr = atoi(apsan_rTok(s,hstr,2));
                    a_def[i].dw_nr = atoi(apsan_rTok(s,hstr,3));
                    a_def[i].bit_nr = atoi(apsan_rTok(s,hstr,4));
                    a_def[i].format_type = atoi(apsan_rTok(s,hstr,5));
                    /* 6 not used */
                    apsan_rTok(s,a_def[i].name,7);
                    set_out(V_DEF,i);
                  }
                }
                break;
    case 1040: /* comment */
                 break;
    default:     break;
   } /* switch */
  } /* while */
  fclose(str_fi);
  apsan_end(s);
  return 1;
}


/* ******************************* */
/* Kommando definieren und in Kommandobuffer schreiben 

*/

void def_command(int typ,int db,int dw,int bit, unsigned long val,double rval)

{
  if (kdo_anz < (KDO_ANZ - 1)) {
    kdo[kdo_anz].db_nr = db; 
    kdo[kdo_anz].dw_nr = dw; 
    kdo[kdo_anz].bit_nr = bit; 
    kdo[kdo_anz].k_type = typ;
    kdo[kdo_anz].lval = val;
    kdo[kdo_anz].val  = rval;
   kdo_anz++;
  }
}

/* ******************************* */
/* Kommando zusammenbauen

Struktur in S5 (S7):
 dw n   (dbw n)   : KM (2#) s1110000 bbbbbbbb 
 (unsigned short)       s =  1 = S5, 0 = S7 
                        b = db-Nr
 dd n+1 (dbd n+2) : KM (2#) Tddd0ttt 00000bbb bbbbbbbbxxx  << S7 Bits 0..7
 dd n+1 (dbd n+2) : KM (2#) Tddd0ttt 00000bbb bbbbbbbxxxx  << S5 Bits 0..15
 (unsigned long)        T = toggle if Dimension = Bit
                  ddd : Dimension
                        0 = Bit
                        1 = Byte
                        2 = --
                        3 = word  
                        4 = dword
                  ttt : 4 = DB (Only DB supported at the moment)
                  bbb : Byte-Nr in DB 
                        ( for Simatic S5   DL: ByteNr +1, (odd Nr)
                                           DR: Bytenr (even Nr) 
                                           generally: Byte-Nr = DW-Nr *2 
                        )
 dd n+3 (dbd n+6)  KH (16#) vvvv vvvv
 (unsigned long)        v = Value

 dw n+5 (dbw(n+10) KH Copy of DW n


*/

void kdo_to_s5db(void)

{
  unsigned short kennung;
  unsigned long bitptr;
  unsigned char dimension;
  unsigned char parameter;
  unsigned char toggle;
  int dwnr;
  signed char valid; 

  
  parameter = 4; /* DB */
  toggle = 0;
  s5db[3] = s5db[4] = 0;  /* Vorbesetzung */
  valid = 1;  
  switch(kdo[0].k_type) {
    case KF16 : set_dw(&(s5db[4]), kdo[0].lval);
                dimension = 3; /* Wort */
                break;
    case KH16 : set_dw(&(s5db[4]),kdo[0].lval);
                dimension = 3; /* Wort */ 
                break;
    case KT16 : set_kt(&(s5db[4]),kdo[0].lval,-1);
                dimension = 3; /* Wort */
                break;
    case KZ16 : set_kz(&(s5db[4]),kdo[0].lval);
                dimension = 3; /* Wort */
                break;
    case KF32 : set_dd(&(s5db[3]),kdo[0].lval);
                dimension = 4; /* Doppelwort */
                break;
    case KH32 : set_dd(&(s5db[3]),kdo[0].lval);
                dimension = 4; /* Doppelwort */
                break;
    case REAL : set_real(&(s5db[3]),kdo[0].val); /* NZE Grenzen pruefen  */
                dimension = 4; /* Doppelwort */
                break;
    case S5KG : set_s5kg(&(s5db[3]),kdo[0].val); /* NZE Grenzen pruefen  */
                dimension = 4; /* Doppelwort */
                break;
    case BIT1 : set_dd(&s5db[3],1); /* Set */
                dimension = 0; /* BIT */
                break;
    case BIT0 : dimension = 0; /* BIT */
                break;
    case BITT : toggle = 1;
                dimension = 0; /* BIT */
                break;
     default  : valid = 0;
                break;
  }
  if (valid == 0)
    return;

  kennung = 0x7000;
  if (simatic_type == 5)
    kennung = 0x8000 | kennung;
  kennung = kennung | kdo[0].db_nr;

  /* byte + bit-Nr */
  if (simatic_type == 5) /* difference S5 / S7 */ 
    dwnr =kdo[0].dw_nr <<1;
  else
    dwnr =kdo[0].dw_nr;

  bitptr = (toggle << 31) | ( dimension << 28 )| (parameter << 24) \
           | (dwnr <<3) | (kdo[0].bit_nr);

  /* zu s5_db schreiben */
  set_dw(&(s5db[0]),kennung);
  set_dd(&(s5db[1]),bitptr);
  /* ... wert siehe oben */
  set_dw(&(s5db[5]),kennung); /* Datenkonsistenz fuer RK511 */
  /*
  printf("kennung : %x\n",kennung);
  printf("kennung : %x\n",s5db[0]);
  printf("db: %04x %04x %04x %04x %04x %04x\n",s5db[0],s5db[1],s5db[2],s5db[3],s5db[4],s5db[5]);
  */
}

/* ******************************* */
/* Kommando direkt schreiben
bei Bit-kommandos wir das Wort erst geholt, das bit manipuliert 
und dann zurückgeschrieben

Falls Wort bzw. Doppelwort schreiben, dann wird der Wert in dem s5db[0] abgelegt;

return-wert : 1 Kommando fertig, nächstes holen
              0 kommando läuft noch
*/

int kdo_direct(int line_state)

{

  static int bits_holen;

  int wort_anz;
  int dwnr;
  int bit_idx;
  signed char valid; 
  unsigned short akku1,akku2;

//  parameter = 4; /* DB */
//  toggle = 0;
printf("kdo_direct(): line_state %i bits_holen %i\n",line_state,bits_holen);
printf("  k_type %i\n",kdo[0].k_type);

  if (bits_holen > 2)
    bits_holen = 2;
  else if (bits_holen == 0) { /* kommando untersuchen */
    bits_holen = 0;
    valid = 1;
    switch(kdo[0].k_type) {
      case KF16 : set_dw(&(s5db[0]), kdo[0].lval);
                  wort_anz = 1; /* Wort */
                  break;
      case KH16 : set_dw(&(s5db[0]),kdo[0].lval);
                  wort_anz = 1; /* Wort */
                  break;
      case KT16 : set_kt(&(s5db[0]),kdo[0].lval,-1);
                  wort_anz = 1; /* Wort */
                  break;
      case KZ16 : set_kz(&(s5db[0]),kdo[0].lval);
                  wort_anz = 1; /* Wort */
                  break;
      case KF32 : set_dd(&(s5db[0]),kdo[0].lval);
                  wort_anz = 2; /* DWort */
                  break;
      case KH32 : set_dd(&(s5db[0]),kdo[0].lval);
                  wort_anz = 2; /* DWort */
                  break;
      case REAL : set_real(&(s5db[0]),kdo[0].val); /* NZE Grenzen pruefen  */
                  wort_anz = 2; /* DWort */
                  break;
      case S5KG : set_s5kg(&(s5db[0]),kdo[0].val); /* NZE Grenzen pruefen  */
                  wort_anz = 2; /* DWort */
                  break;
      case BIT1 : bits_holen = 2; /* Anforderung Bitstatus holen */
                  wort_anz = 1; /* Wort */
                  break;
      case BIT0 : bits_holen = 2; /* Anforderung Bitstatus holen */
                  wort_anz = 1; /* Wort */
                  break;
      case BITT : bits_holen = 2; /* Anforderung Bitstatus holen */
                  wort_anz = 1; /* Wort */
                  break;
       default  : valid = 0;
                  break;
    }
    if (valid == 0) {
      return 1;
    }
    if (bits_holen == 0) { /*direkt schreiben, kein Status holen notwendig */
      /* byte + bit-Nr */
      if (simatic_type != 5) /* difference S5 / S7 */ 
        dwnr =kdo[0].dw_nr >> 1;
      else
        dwnr =kdo[0].dw_nr;
printf("simatic_type = %i\n",simatic_type);
 printf("schreiben nach DB%i.DBB%i Worte = %i\n",kdo[0].db_nr,dwnr,wort_anz);
      write_command(s5db,'D',cpu_nr,kdo[0].db_nr,dwnr *2,wort_anz*2);
      return 1;
    }
  }
  if (bits_holen == 2) { /*Status holen: Leseauftrag*/
    /* byte + bit-Nr */
    if (simatic_type != 5) /* difference S5 / S7 */ 
      dwnr =kdo[0].dw_nr >> 1;
    else
      dwnr =kdo[0].dw_nr;
    fetch_command(s5db,'D',cpu_nr,kdo[0].db_nr,dwnr *2,wort_anz *2);
    bits_holen = 1; // Nächster Zyklus: Warten auf Daten
    return 0;
  }
  else if (bits_holen == 1) { /* Warten bis Status da */
    if ((line_state == 1 ) ||(line_state == 4 )) { /* Bits sind da */

      akku1 = get_dw(&(s5db[0]));
printf("gelesen: s5db: %i %i\n",s5db[0],akku1);
      bit_idx = kdo[0].bit_nr ;
      if (simatic_type != 5) {
        if ((kdo[0].dw_nr & 1) == 0 ) {
          bit_idx = bit_idx + 8;
        }
      }
      akku2 = ( 1 << bit_idx );
      switch(kdo[0].k_type) {
        case BIT1 : akku1 = akku1 | akku2; /* Bit setzen */
                    break;
        case BIT0 : akku1 = akku1 & ( ~akku2);  /* Bit ruecksetzen  */
                    break;
        case BITT : akku1 = akku1 ^ akku2;  /* Bit toggeln */
                    break;
        default  : valid = 0;
                    break;
      }
      set_dw(&(s5db[0]), akku1);
      if (simatic_type != 5) /* difference S5 / S7 */ 
        dwnr =kdo[0].dw_nr >> 1;
      else
        dwnr =kdo[0].dw_nr;
printf("schreiben: s5db: %i %i\n",s5db[0],akku1);
      write_command(s5db,'D',cpu_nr,kdo[0].db_nr,dwnr*2,2);
      bits_holen = 0;
      return 1;
    }

    else if ( line_state < 0) { // Fehler : Kommando abbrechen 
      bits_holen = 0;
      return 1;
    }
  }
  return 0;
}


/* ------------- kdo_del_first ------------ */
/* erstes Kommando aus der Kommandoliste loeschen und dahinterliegende
   nach vorne kopieren 
*/
 
void kdo_del_first(void)
{
  int j;
 
  for (j=0;j<kdo_anz-1;j++) {
    kdo[j].k_type = kdo[j+1].k_type;
    kdo[j].bit_nr = kdo[j+1].bit_nr;
    kdo[j].db_nr  = kdo[j+1].db_nr;
    kdo[j].dw_nr  = kdo[j+1].dw_nr;
    kdo[j].lval   = kdo[j+1].lval;
    kdo[j].val    = kdo[j+1].val;
  } 
  kdo_anz-- ;
}

/* ------------- display_con_state ------------ */

void display_con_state(int fstate) // display connection state

{
  char hstr[256];
  FL_COLOR col;

  if (fstate == 4) return;

  /* positive rk_error may been overwritten by positive and negative
   while negative  rk_error only can be overwritten by negative fstate.
  */
  if (rk_error >=0)
    rk_error = fstate;
  else { // rk_error is negative (=fault)
    if (fstate < 0)  rk_error = fstate;
  }

  // select color
  if (rk_error > 0)
    col = FL_GREEN;
  else if (rk_error < 0)
    col = FL_RED;
  else
    col = FL_LIGHTER_COL1;
  // text
  if (rk_error == 1111 )
    fl_set_object_label(fd_pult->link_msg,"successfully connected to server but yet no operations to plc");
  else
  if (rk_error == 0 )
    fl_set_object_label(fd_pult->link_msg," -- ");
  else
  if (rk_error == 1 )
    fl_set_object_label(fd_pult->link_msg,"FETCH OK");
  else
  if (rk_error == 2 )
    fl_set_object_label(fd_pult->link_msg,"WRITE OK");
  else
    fl_set_object_label(fd_pult->link_msg,rk7_errortext_en(rk_error));
  fl_set_object_color(fd_pult->link_msg,col,col);
}

/* ------------- display_pgm_state ------------ */
/*
  higher priority of  p_errors ( = Programm pult) than rk_errors (=server)
  but a positive p_error is reset by a rk_error, pos , or neg.

  fstate = -1000 : Reset;

  p_error = -1 max count of pa-blocks

*/

void display_pgm_state(int fstate) // display program state

{
  char hstr[256];
  FL_COLOR col;

  if (fstate == -1000 ) { // Reset p_error
    fstate = p_error = 0;
  }

  /* positive p_error may been overwritten by positive and negative
   while negative  p_error only can be overwritten by negative fstate.
  */
  if (fstate != 0) {
    if (p_error >=0)
      p_error = fstate;
    else { // p_error is negative (=fault)
     if (fstate < 0)  p_error = fstate;
    }
  }
  switch (p_error) {
    case -1    : sprintf(hstr,"maximum count of pa blocks reached: %i",PA_ANZ);
                break;
    case     1 : sprintf(hstr,"used pa blocks: %i of %i",pa_anz,PA_ANZ);
                break;
    case     0 : sprintf(hstr," -- ");
                break;
    default : break;
  }
  fl_set_object_label(fd_pult->pgm_msg,hstr);
  if (p_error >= 0)
    col = FL_YELLOW;
  else
    col = FL_RED;
  fl_set_object_color(fd_pult->pgm_msg,col,col);
}


/* ------------- background_programm ------------ */
/*  called by timer background */

int background(void)

{
  int j;
  signed char function;
  static int pa_nr; 
  static int fstate;

  static int kdo_line_state ;

  int wstate;
  int db,dw,len;
  char hstr[20];

  if (online == 0)
    op_mode = OPMODE_PROG;
  // display operations mode
  if ( op_mode != op_mode_old) {
    if (op_mode == OPMODE_PROG) {
      fl_set_button(fd_pult->tba_pgm,1);
      fl_set_button(fd_pult->tba_run,0);
      fl_set_button(fd_pult->tba_test,0);
      fl_set_object_color(fd_pult->tba_test,FL_COL1,FL_COL1);
      fl_set_object_color(fd_pult->tba_pgm,FL_GREEN,FL_GREEN);
      fl_set_object_color(fd_pult->tba_run,FL_COL1,FL_COL1);
    }
    if (op_mode == OPMODE_RUN) {
      fl_set_button(fd_pult->tba_pgm,0);
      fl_set_button(fd_pult->tba_run,1);
      fl_set_button(fd_pult->tba_test,0);
      fl_set_object_color(fd_pult->tba_test,FL_COL1,FL_COL1);
      fl_set_object_color(fd_pult->tba_pgm,FL_COL1,FL_COL1);
      fl_set_object_color(fd_pult->tba_run,FL_GREEN,FL_GREEN);
    }
    if (op_mode == OPMODE_TEST) {
      fl_set_button(fd_pult->tba_pgm,0);
      fl_set_button(fd_pult->tba_run,0);
      fl_set_button(fd_pult->tba_test,1);
      fl_set_object_color(fd_pult->tba_test,FL_GREEN,FL_GREEN);
      fl_set_object_color(fd_pult->tba_pgm,FL_COL1,FL_COL1);
      fl_set_object_color(fd_pult->tba_run,FL_COL1,FL_COL1); 
    }
    op_mode_old = op_mode;
  }

  /* fetch-Schleife durch Prozesabbilder */
  /* fetch loop actualizing Process images */
  /* --------- */
  if ( (op_mode == OPMODE_RUN )
     && (pa_anz>0)
     && ( (fstate == 4) ||(fstate == 1))
     && (simatic_unlink_req == 0)
    ) {
    pa_nr++ ;
    if (pa_nr >= pa_anz) pa_nr = 0; /* Schleife durch Prozessabblilder */

    /* fetch pa.. data */
/*    printf("RUN pa_idx = %i,DB%i.DBb%i len %i\n",
		       pa_nr,pa[pa_nr].db_nr,pa[pa_nr].dw_nr,pa[pa_nr].len);
*/
    j = fetch_start( (void *)pa[pa_nr].dw,'D', \
            pa[pa_nr].db_nr,pa[pa_nr].dw_nr,pa[pa_nr].len,cpu_nr);
    if (j < 0 ) read_lstat = -1; else if (j ==1 ) read_lstat = 1;
  }

  if (op_mode == OPMODE_TEST ) { /* Test-Control */
    test_output();
    // printf("test mode: step %i\n",test_stp);
  }
  else if ((test_stp != 0) || (recalc_pa_req)) {
    calc_pa();         /* rebuild pa */
    test_stp = 0;
    recalc_pa_req = 0;
  }

  if(online == 1) {
    fl_set_object_label(fd_pult->connect,"Connected");
    fl_set_object_color(fd_pult->connect,FL_GREEN,FL_GREEN);
  } else {
    fl_set_object_label(fd_pult->connect,"Disconnected");
    fl_set_object_color(fd_pult->connect,FL_RED,FL_RED);
  }

//  fstate = 0;
  if (op_mode == OPMODE_RUN) {
     fstate = fetch_ready();
     if (fstate == 1)              /* no error */
       output(0,pa_nr); 	  /* felder aktualisieren   update display according to the pa-number */
     if (fstate <0)                /* error */
       output(1,pa_nr); 	  /* felder aktualisieren   update display */
     display_con_state(fstate);
     if (fstate < 0 ) 
       read_lstat = -1;
     else if (fstate ==1 )
       read_lstat = 1;

//     printf("RUN mode: step %i\n",fstate);
  }

  /* Kommandos/Daten nach Simatic schreiben */
  /* Write commands to Simatic, if exist */
  if (online) {
    /* wenn Auftrag frei, Kommandos schreiben */
    /* if idle, write commands */
    if ( kdo_line_state = write_ready()   && (kdo_anz > 0) ) {
      if (access_mode == KDO_DB_MODE) {
        kdo_to_s5db(); /* Kommando in Sendebuffer schreiben */
        /* Kommando Senden */   
        write_command(s5db,'D',cpu_nr,kdo_dbnr,(2*kdo_dwnr/bytenr_pro_word),12);
        /* Kommando aus liste loeschen */
        kdo_del_first();
      } else { /* direkt-Zugriff */
        if (kdo_direct(kdo_line_state) == 1) {
           /* Kommando aus liste loeschen */
           kdo_del_first();
        }
      }
    }
   if (kdo_line_state < 0) write_lstat = -1; else write_lstat = 0;
  }
  /* displaying the communication states */
  if (read_lstat < 0)
    fl_set_object_color(fd_pult->read_stat,FL_RED,FL_RED);
  else if (read_lstat > 0)
    fl_set_object_color(fd_pult->read_stat,FL_GREEN,FL_GREEN);
  else
    fl_set_object_color(fd_pult->read_stat,FL_COL1,FL_COL1);

  if (write_lstat < 0)
    fl_set_object_color(fd_pult->write_stat,FL_RED,FL_RED);
  else  if (write_lstat > 0)
    fl_set_object_color(fd_pult->write_stat,FL_GREEN,FL_GREEN);
  else
    fl_set_object_color(fd_pult->write_stat,FL_COL1,FL_COL1);

  display_pgm_state(0); // only display

  sprintf(hstr,"%3i",pa_nr);
  fl_set_object_label(fd_pult->pa_idx,hstr);

}
