/* ****************************************************************

   Pult2   - Hauptprogramm -

  (c) Heisch Automatisierungstechnik, Werner Heisch
       http://sites.inka.de/heisch 

* *****************************************************************
Stand 18.02.2009 HW 
      Reihenfolge rc-file structur-file geändert.
Stand 19.01.2009 HW

Stand 2000.05.16 HW  V 0.15
      Meldung, wenn keine Verbindung zum Server
Stand 2000.05.15 HW
      rk512-rc-file eingebaut

*/

#include <stdlib.h>
#include <math.h>
#include <locale.h>

/*
#include <ft2build.h>
#include FT_FREETYPE_H
*/

#include "forms.h"
#include "p2.h"
#include "p2_data.h"
#include "svr_info.h"
#include "simatic_link.h"

/* ----------------------------------------- */

extern void init_new_struct(void);
extern void display_con_state(int fstate); // display connection state

/* ******************************** */


void logo(void)

{ 
  printf("Pult2 V 0.4  built %s %s\n",__DATE__, __TIME__);
  printf("(c) Heisch Automation 2000,2016 ff\n");
}

/* ******************************** */

void usage(void)

{ 
  printf("pult2 <rk512_rc_file>\n");
  printf("  or:\n");
  printf("pult [-r <rk512_rc_file> ] [-s <struct_file>]\n");
  printf("  while:\n");
  printf("      [-r <rk512_rc_file>]  : rk512-rc-file \n");
  printf("      [-s <stru_file>]      : data structure file \n");
}


/* ******************************** */
int read_args(int argc, char **argv)

{
  int i = 1;
  char *p;

  // printf("argc = %i\n",argc); fflush(stdout);
  if (argc == 2) {
    if (argv[1][0] != '-') { 
      sstrcpy(rkrc_fi,argv[1],sizeof rkrc_fi);
      /* kurzform des rc-file-namens ermittlen */
      sep_dir_finam(rkrc_dir,sizeof rkrc_dir,
         rkrc_fi_short,sizeof rkrc_fi_short,
         rkrc_fi);

      /* rc-directory ermitteln */

      if (strlen(rkrc_dir) <1) { /* das directory wurde nicht angegeben */
        sstrcpy(rkrc_dir,home_dir_name,sizeof rkrc_dir);
      }
      rc_defined = 1;
      return 0;
     } else {
        return -1;
     }
  }
  while (i< argc) {
    if (strcmp(argv[i], "-h") == 0) { /* usage */
        logo();
        usage();
        return -1;
    } 
    if (strcmp(argv[i], "-r") == 0) { /* rk512-rc-name should follow */
      if (( i + 1) >= argc) { /* nothing is following */ 
        printf("ERROR in commandline: -r <argument> missing\n");
        return -1;
      } 
      sstrcpy(rkrc_fi,argv[i+1],sizeof rkrc_fi);
      sep_dir_finam(rkrc_dir,sizeof rkrc_dir,
         rkrc_fi_short,sizeof rkrc_fi_short,
         rkrc_fi);
      if (strlen(rkrc_dir) <1) { /* das directory wurde nicht angegeben */
        sstrcpy(rkrc_dir,home_dir_name,sizeof rkrc_dir);
      }
      rc_defined = 1;
      i = i +2;
    } else if (strcmp(argv[i], "-s") == 0) { /* Structure file name  */
      if (( i + 1) >= argc) { /* nothing is following */ 
        printf("ERROR in commandline: -s <argument> missing\n");
        return -1;
      } 
      sstrcpy(structfi_name,argv[i+1],sizeof structfi_name);
      struct_defined = 1;
      i = i +2;
      printf("-s gefunden: >%s<\n",structfi_name);
    } else { /* Parameter is rc-filename */
      printf("ERROR in commandline: arguments missing\n");
      return -1;
    }
  }
  return 0;
}

/* --------------- idle_callback -------------------------- */

static int idle_cb (XEvent *a, void *b)

{
  // printf("idle..");fflush(stdout);
  background();
  // printf("Ende\n");fflush(stdout);
} 




/* --------------- Hauptprogramm -------------------------- */

main ( int argc, char *argv[] )

{

char dummystr[1000];

char *dummyptr;

char *env; /* Hilfspointer zum ermitteln der Home-directory */
int i;
int con_state;

  /* Initialisierungen */

  struct_defined = 0;
  structure_open = 0; /* Stuktur geoeffnet (=1)*/
; 
/*  Directories vorbesetzen */ 

  /* Home-Directory ermitteln */
  if ((env = getenv("PWD")) != NULL) {
    strcpy(home_dir_name,env);
  printf("PWD = %s\n",env);
  } else {
    strcpy(home_dir_name,".");
  printf("PWD = %s\n",env);
  }
  printf("home_dir_name = %s\n",home_dir_name);
  sstrcpy(struct_dir,home_dir_name,sizeof struct_dir);  	/* Arbeitsdirectory */
  strcpy(structfi_name_short,"Noname.stp");

  strcpy(wdir,home_dir_name);  	/* Arbeitsdirectory */

  /* rc-directory vorbesetzen */
  strcpy(rkrc_dir,"/usr/local/bin");

  if (read_args(argc,argv) != 0) {
    logo();
    usage();
    return -1;
  }

  /* Betriebsart voreinstellen : STOP */
  op_mode = OPMODE_PROG;
  simatic_type = 7;  /* S7 */
  access_mode = 1 ; /* direct */
  bytenr_pro_word = 2; /* S7-adressierung */

  help_open = 0; /* Hilfe-/Copyright-Stuktur geoeffnet (=1)*/

  pa_anz = 0; /* Prozessabbilder loeschen */
  for (i=0;i<PA_ANZ;i++) {
    pa[i].db_nr = 0;
    pa[i].dw_nr = 0;
    pa[i].len = 0;
  }
  /* Kommando-Liste loeschen */
  kdo_anz = 0;
  kdo_dbnr = 255;
  kdo_dwnr = 0;

  /* Start pult-Programm */

  fl_initialize(&argc,argv,"Pult",0,0);
  /* locale abschalten */
  setlocale(LC_NUMERIC,"C"); /* locale-Definitionen abschalten */

  /* alle forms definieren, erleichtert Speicher-Handling */
  fd_pult = create_form_pult();
  // on default,the positioners only react on letft mous button,
  // but we also need reactin at right mous button as well
  fl_set_positioner_mouse_buttons(fd_pult->posit_ew1,( 1 | 4));
  fl_set_positioner_mouse_buttons(fd_pult->posit_ew2,( 1 | 4));
  fl_set_positioner_mouse_buttons(fd_pult->posit_ew3,( 1 | 4));
  fl_set_positioner_mouse_buttons(fd_pult->posit_aw1,( 1 | 4));
  fl_set_positioner_mouse_buttons(fd_pult->posit_aw2,( 1 | 4));
  fl_set_positioner_mouse_buttons(fd_pult->posit_aw3,( 1 | 4));
  fl_set_positioner_mouse_buttons(fd_pult->posit_a,( 1 | 4));

  fd_version_dt = create_form_version_dt();
  fd_version_en = create_form_version_en();
  fd_help_dt = create_form_help_dt();
  fd_help_en = create_form_help_en();
  fd_kdo_db_structure = create_form_kdo_db_structure();
  fd_e_structure = create_form_e_structure();
  fd_ew_structure = create_form_ew_structure();
  fd_ew_input = create_form_ew_input();
  fd_a_structure = create_form_a_structure();
  fd_aw_structure = create_form_aw_structure();
  fd_svr_info = create_form_svr_info();

  fl_show_form(fd_pult->pult,FL_PLACE_MOUSE,FL_FULLBORDER,"Pult2");

  /* wenn structure als comandline-parameter, dann oeffnen */
  if (struct_defined > 0) {
    if (i = sep_dir_finam(dummystr,1000, \
            structfi_name_short,sizeof structfi_name_short,\
            structfi_name) < 0 ) { /* Fehler bein Trennen der Namen */
       printf("sep_dir_finam() error %i\n",i);
    }
    struct_defined = lese_structur(structfi_name) ;

    calc_pa(); /* Prozessabbild-Tabelle anlegen */
    if (struct_defined == 1 ) {
      fl_set_object_color(fd_pult->d_structur,FL_TOP_BCOL,FL_TOP_BCOL);
    } else if  (struct_defined == -1 ) {
      fl_set_object_color(fd_pult->d_structur,FL_RED,FL_RED);
    }
    fl_set_object_label(fd_pult->d_structur,structfi_name); /* Strukturfile */
  }
  /* wenn rc-file als comandline-parameter, dann öffnen,
     definition in structure file ueberschreiben  */
  if (rc_defined != 0) {
     printf("rc-file definiert .. lesen \n");
     fl_set_object_label(fd_pult->rc_file,rkrc_fi); /* rc-file */
  }
  /* Verbindung zur Simatic aufbauen */
  if (rc_defined == 1) {
    if ((con_state = simatic_open(rkrc_fi)) == 1111) {
      write_lstat = read_lstat = 0;
    }
    display_con_state(con_state);
  } else {
      write_lstat = read_lstat = -1;
  }

  if (online == 0) {
    fl_show_message("Curently no connection to",\
       "rk512_server or rk511_server",\
       "start server first");
    fl_call_object_callback(fd_pult->tba_pgm);
  } else {
    fl_call_object_callback(fd_pult->tba_run);
  }
  fl_set_idle_callback(idle_cb,dummyptr);

  fl_do_forms();
  fl_hide_form(fd_pult->pult);
  return(0);
}

 
